
//	HID Minidriver for Microsoft Xbox 360 Controller

#include	"X360C.h"

//----------------------------------------------------------------------------------------------
//	O[oϐ錾
//----------------------------------------------------------------------------------------------

SHORT	DirectionalPad[]	= {			//	E,,    
								 0		//	 0, 0,     0
								,-32768	//	 0, 1,-32768
								,32767	//	 1, 0, 32767
								,0 };	//	 1, 1,     0

UCHAR	HatSwitchArray[]	= {			//	E,,,,px
								 -1		//	 0, 0, 0, 0,  -1
								,0		//	 0, 0, 0, 1,   0
								,4		//	 0, 0, 1, 0, 180
								,-1		//	 0, 0, 1, 1,  -1
								,6		//	 0, 1, 0, 0, 270
								,7		//	 0, 1, 0, 1, 315
								,5		//	 0, 1, 1, 0, 225
								,-1		//	 0, 1, 1, 1,  -1
								,2		//	 1, 0, 0, 0,  90
								,1		//	 1, 0, 0, 1,  45
								,3		//	 1, 0, 1, 0, 135
								,-1		//	 1, 0, 1, 1,  -1
								,-1		//	 1, 1, 0, 0,  -1
								,-1		//	 1, 1, 0, 1,  -1
								,-1		//	 1, 1, 1, 0,  -1
								,-1 };	//	 1, 1, 1, 1,  -1

ULONG	Button[]	= {	 0x00000001		//	{^ 1
						,0x00000002		//	{^ 2
						,0x00000004		//	{^ 3
						,0x00000008		//	{^ 4
						,0x00000010		//	{^ 5
						,0x00000020		//	{^ 6
						,0x00000040		//	{^ 7
						,0x00000080		//	{^ 8
						,0x00000100		//	{^ 9
						,0x00000200		//	{^ 10
						,0x00000400		//	{^ 11
						,0x00000800		//	{^ 12
						,0x00001000		//	{^ 13
						,0x00002000		//	{^ 14
						,0x00004000		//	{^ 15
						,0x00008000		//	{^ 16
						,0x00010000		//	{^ 17
						,0x00020000		//	{^ 18
						,0x00040000		//	{^ 19
						,0x00080000		//	{^ 20
						,0x00100000		//	{^ 21
						,0x00200000		//	{^ 22
						,0x00400000		//	{^ 23
						,0x00800000		//	{^ 24
						,0x01000000		//	{^ 25
						,0x02000000		//	{^ 26
						,0x04000000		//	{^ 27
						,0x08000000		//	{^ 28
						,0x10000000		//	{^ 29
						,0x20000000		//	{^ 30
						,0x40000000		//	{^ 31
						,0x80000000 };	//	{^ 32

//----------------------------------------------------------------------------------------------
//	X360C_GenerateInputReport
//----------------------------------------------------------------------------------------------
NTSTATUS X360C_GenerateInputReport(
	 IN PDEVICE_EXTENSION	DeviceExtension
	,OUT REPORT *			Report )
{
	//	ϐ錾
	NTSTATUS		Status						= STATUS_SUCCESS;
	PINPUT_REPORT	InputReport					= &DeviceExtension->InputReport;
	SETTING *		Setting						= &DeviceExtension->Setting;
	LONG			Index;
	//	XeBbN
	SHORT			Stick_XAxis[2]				= {	 InputReport->LeftStickX
													,InputReport->RightStickX };
	SHORT			Stick_YAxis[2]				= {	 InputReport->LeftStickY
													,InputReport->RightStickY };
	UCHAR			Stick_HatSwitch[2]			= { 0, 0 };
	//	gK[
	UCHAR			Trigger_Slider[2]			= {	 InputReport->LeftTrigger
													,InputReport->RightTrigger };
	ULONG			Trigger_Button[2]			= { 0, 0 };
	//	pbh
	UCHAR			DirectionalPadWay_Slider[4]	= {
						 InputReport->DigitalButton & DIRECTIONAL_PAD_UP ? 255 : 0
						,InputReport->DigitalButton & DIRECTIONAL_PAD_DOWN ? 255 : 0
						,InputReport->DigitalButton & DIRECTIONAL_PAD_LEFT ? 255 : 0
						,InputReport->DigitalButton & DIRECTIONAL_PAD_RIGHT ? 255 : 0 };
	ULONG			DirectionalPadWay_Button[4]	= {
						 InputReport->DigitalButton & DIRECTIONAL_PAD_UP
						,InputReport->DigitalButton & DIRECTIONAL_PAD_DOWN
						,InputReport->DigitalButton & DIRECTIONAL_PAD_LEFT
						,InputReport->DigitalButton & DIRECTIONAL_PAD_RIGHT };
	//	{^
	UCHAR			Button_Slider[11]			= {
						 InputReport->DigitalButton & A_BUTTON ? 255 : 0
						,InputReport->DigitalButton & B_BUTTON ? 255 : 0
						,InputReport->DigitalButton & X_BUTTON ? 255 : 0
						,InputReport->DigitalButton & Y_BUTTON ? 255 : 0
						,InputReport->DigitalButton & LB_BUTTON ? 255 : 0
						,InputReport->DigitalButton & RB_BUTTON ? 255 : 0
						,InputReport->DigitalButton & START_BUTTON ? 255 : 0
						,InputReport->DigitalButton & BACK_BUTTON ? 255 : 0
						,InputReport->DigitalButton & LEFT_STICK_BUTTON ? 255 : 0
						,InputReport->DigitalButton & RIGHT_STICK_BUTTON ? 255 : 0
						,InputReport->DigitalButton & XBOX_GUIDE_BUTTON ? 255 : 0 };
	ULONG			Button_Button[11]			= {
						 InputReport->DigitalButton & A_BUTTON
						,InputReport->DigitalButton & B_BUTTON
						,InputReport->DigitalButton & X_BUTTON
						,InputReport->DigitalButton & Y_BUTTON
						,InputReport->DigitalButton & LB_BUTTON
						,InputReport->DigitalButton & RB_BUTTON
						,InputReport->DigitalButton & START_BUTTON
						,InputReport->DigitalButton & BACK_BUTTON
						,InputReport->DigitalButton & LEFT_STICK_BUTTON
						,InputReport->DigitalButton & RIGHT_STICK_BUTTON
						,InputReport->DigitalButton & XBOX_GUIDE_BUTTON };
	//	Q[pbh̏
#if( WINVER < 0x0500 )
	USHORT			Axis[4]						= { 32767, 32767, 32767, 32767 };
#else
	SHORT			Axis[4]						= { 0, 0, 0, 0 };
#endif
	UCHAR			HatSwitch[4]				= { 0, 0, 0, 0 };
	SHORT			Slider[4]					= { 0, 0, 0, 0 };
	ULONG			ButtonState					= 0;
	ULONG			Dummy						= 0;
	SHORT			ZAxisValue					= 0;
	SHORT			ZRotationValue				= 0;
	SHORT			Slider1Value				= 0;
	SHORT			Slider2Value				= 0;

	//	XeBbN̕␳̒l쐬
	X360C_AdjustStick_Axis(
		 Setting->StickDeadZoneType
		,&Stick_XAxis[0]
		,&Stick_YAxis[0]
		,Setting->StickMinThreshold
		,Setting->StickMaxThreshold );
	X360C_AdjustStick_HatSwitch(
		 &Stick_HatSwitch[0]
		,InputReport->LeftStickX
		,InputReport->LeftStickY
		,Setting->StickHatSwitchThreshold );
	X360C_AdjustStick_Axis(
		 Setting->StickDeadZoneType
		,&Stick_XAxis[1]
		,&Stick_YAxis[1]
		,Setting->StickMinThreshold
		,Setting->StickMaxThreshold );
	X360C_AdjustStick_HatSwitch(
		 &Stick_HatSwitch[1]
		,InputReport->RightStickX
		,InputReport->RightStickY
		,Setting->StickHatSwitchThreshold );

	//	gK[̕␳̒l쐬
	X360C_AdjustSlider_Slider(
		 &Trigger_Slider[0]
		,Setting->TriggerMinThreshold
		,Setting->TriggerMaxThreshold );
	X360C_AdjustSlider_Button(
		 &Trigger_Button[0]
		,InputReport->LeftTrigger
		,Setting->TriggerButtonThreshold );
	X360C_AdjustSlider_Slider(
		 &Trigger_Slider[1]
		,Setting->TriggerMinThreshold
		,Setting->TriggerMaxThreshold );
	X360C_AdjustSlider_Button(
		 &Trigger_Button[1]
		,InputReport->RightTrigger
		,Setting->TriggerButtonThreshold );

	//	XeBbN
	for( Index = 0; Index< 2; Index ++ )
	{
		switch( Setting->StickUsage[Index] )
		{
			case 0:
			case 1:
				X360C_SetAxisRotation(
					 Axis
					,Stick_XAxis[Index]
					,Stick_YAxis[Index]
					,Setting->StickUsage[Index]
					,Setting->StickReverse[Index] );
				break;

			case 2:
			case 3:
			case 4:
			case 5:
			case 6:
			case 7:
			case 8:
			case 9:
			case 10:
			case 11:
			case 12:
			case 13:
				switch( Setting->StickUsage[Index] )
				{
					case 2:
						ZAxisValue		= Stick_XAxis[Index];
						ZRotationValue	= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							ZRotationValue	= max( ZRotationValue, -32767 ) * -1;
						}
						break;

					case 3:
						ZAxisValue		= Stick_XAxis[Index];
						Slider1Value	= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							Slider1Value	= max( Slider1Value, -32767 ) * -1;
						}
						break;

					case 4:
						ZAxisValue		= Stick_XAxis[Index];
						Slider2Value	= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							Slider2Value	= max( Slider2Value, -32767 ) * -1;
						}
						break;

					case 5:
						ZRotationValue	= Stick_XAxis[Index];
						ZAxisValue		= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							ZAxisValue		= max( ZAxisValue, -32767 ) * -1;
						}
						break;

					case 6:
						ZRotationValue	= Stick_XAxis[Index];
						Slider1Value	= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							Slider1Value	= max( Slider1Value, -32767 ) * -1;
						}
						break;

					case 7:
						ZRotationValue	= Stick_XAxis[Index];
						Slider2Value	= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							Slider2Value	= max( Slider2Value, -32767 ) * -1;
						}
						break;

					case 8:
						Slider1Value	= Stick_XAxis[Index];
						ZAxisValue		= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							ZAxisValue		= max( ZAxisValue, -32767 ) * -1;
						}
						break;

					case 9:
						Slider1Value	= Stick_XAxis[Index];
						ZRotationValue	= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							ZRotationValue	= max( ZRotationValue, -32767 ) * -1;
						}
						break;

					case 10:
						Slider1Value	= Stick_XAxis[Index];
						Slider2Value	= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							Slider2Value	= max( Slider2Value, -32767 ) * -1;
						}
						break;

					case 11:
						Slider2Value	= Stick_XAxis[Index];
						ZAxisValue		= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							ZAxisValue		= max( ZAxisValue, -32767 ) * -1;
						}
						break;

					case 12:
						Slider2Value	= Stick_XAxis[Index];
						ZRotationValue	= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							ZRotationValue	= max( ZRotationValue, -32767 ) * -1;
						}
						break;

					case 13:
						Slider2Value	= Stick_XAxis[Index];
						Slider1Value	= Stick_YAxis[Index];
						if( Setting->StickReverse[Index] != 0 )
						{
							Slider1Value	= max( Slider1Value, -32767 ) * -1;
						}
						break;
				}
				if( Setting->SlideSliderValue[0] == 0 && ZAxisValue < 0 )
				{
					ZAxisValue	= max( ZAxisValue, -32767 ) * -1;
				}
				if( Setting->SlideSliderValue[1] == 0 && ZRotationValue < 0 )
				{
					ZRotationValue	= max( ZRotationValue, -32767 ) * -1;
				}
				if( Setting->SlideSliderValue[2] == 0 && Slider1Value < 0 )
				{
					Slider1Value	= max( Slider1Value, -32767 ) * -1;
				}
				if( Setting->SlideSliderValue[3] == 0 && Slider2Value < 0 )
				{
					Slider2Value	= max( Slider2Value, -32767 ) * -1;
				}
				X360C_SetSlider( Slider, ZAxisValue >> 7, 0, 0, 100, &Dummy, &Dummy );
				X360C_SetSlider( Slider, ZRotationValue >> 7, 2, 0, 100, &Dummy, &Dummy );
				X360C_SetSlider( Slider, Slider1Value >> 7, 4, 0, 100, &Dummy, &Dummy );
				X360C_SetSlider( Slider, Slider2Value >> 7, 6, 0, 100, &Dummy, &Dummy );
				break;

			case 14:
			case 15:
			case 16:
			case 17:
				X360C_SetHatSwitch(
					 HatSwitch
					,Stick_HatSwitch[Index]
					,Setting->StickUsage[Index]
					,Setting->StickReverse[Index] );
				break;
		}
	}

	//	pbh
	switch( Setting->DirectionalPadUsage )
	{
		case 0:
		case 1:
			X360C_SetAxisRotation(
				 Axis
				,DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ]
				,DirectionalPad[ InputReport->DigitalButton & 0x03 ]
				,Setting->DirectionalPadUsage
				,Setting->DirectionalPadReverse );
			break;

		case 2:
		case 3:
		case 4:
		case 5:
		case 6:
		case 7:
		case 8:
		case 9:
		case 10:
		case 11:
		case 12:
		case 13:
			switch( Setting->DirectionalPadUsage )
			{
				case 2:
					ZAxisValue		= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					ZRotationValue	= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						ZRotationValue	= max( ZRotationValue, -32767 ) * -1;
					}
					break;

				case 3:
					ZAxisValue		= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					Slider1Value	= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						Slider1Value	= max( Slider1Value, -32767 ) * -1;
					}
					break;

				case 4:
					ZAxisValue		= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					Slider2Value	= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						Slider2Value	= max( Slider2Value, -32767 ) * -1;
					}
					break;

				case 5:
					ZRotationValue	= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					ZAxisValue		= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						ZAxisValue		= max( ZAxisValue, -32767 ) * -1;
					}
					break;

				case 6:
					ZRotationValue	= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					Slider1Value	= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						Slider1Value	= max( Slider1Value, -32767 ) * -1;
					}
					break;

				case 7:
					ZRotationValue	= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					Slider2Value	= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						Slider2Value	= max( Slider2Value, -32767 ) * -1;
					}
					break;

				case 8:
					Slider1Value	= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					ZAxisValue		= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						ZAxisValue		= max( ZAxisValue, -32767 ) * -1;
					}
					break;

				case 9:
					Slider1Value	= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					ZRotationValue	= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						ZRotationValue	= max( ZRotationValue, -32767 ) * -1;
					}
					break;

				case 10:
					Slider1Value	= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					Slider2Value	= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						Slider2Value	= max( Slider2Value, -32767 ) * -1;
					}
					break;

				case 11:
					Slider2Value	= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					ZAxisValue		= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						ZAxisValue		= max( ZAxisValue, -32767 ) * -1;
					}
					break;

				case 12:
					Slider2Value	= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					ZRotationValue	= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						ZRotationValue	= max( ZRotationValue, -32767 ) * -1;
					}
					break;

				case 13:
					Slider2Value	= DirectionalPad[ ( InputReport->DigitalButton & 0x0f ) >> 2 ];
					Slider1Value	= DirectionalPad[ InputReport->DigitalButton & 0x03 ];
					if( Setting->DirectionalPadReverse != 0 )
					{
						Slider1Value	= max( Slider1Value, -32767 ) * -1;
					}
					break;
			}
			if( Setting->SlideSliderValue[0] == 0 && ZAxisValue < 0 )
			{
				ZAxisValue	= max( ZAxisValue, -32767 ) * -1;
			}
			if( Setting->SlideSliderValue[1] == 0 && ZRotationValue < 0 )
			{
				ZRotationValue	= max( ZRotationValue, -32767 ) * -1;
			}
			if( Setting->SlideSliderValue[2] == 0 && Slider1Value < 0 )
			{
				Slider1Value	= max( Slider1Value, -32767 ) * -1;
			}
			if( Setting->SlideSliderValue[3] == 0 && Slider2Value < 0 )
			{
				Slider2Value	= max( Slider2Value, -32767 ) * -1;
			}
			X360C_SetSlider( Slider, ZAxisValue >> 7, 0, 0, 100, &Dummy, &Dummy );
			X360C_SetSlider( Slider, ZRotationValue >> 7, 2, 0, 100, &Dummy, &Dummy );
			X360C_SetSlider( Slider, Slider1Value >> 7, 4, 0, 100, &Dummy, &Dummy );
			X360C_SetSlider( Slider, Slider2Value >> 7, 6, 0, 100, &Dummy, &Dummy );
			break;

		case 14:
		case 15:
		case 16:
		case 17:
			X360C_SetHatSwitch(
				 HatSwitch
				,InputReport->DigitalButton & 0x0f
				,Setting->DirectionalPadUsage
				,Setting->DirectionalPadReverse );
			break;

		case 18:
			//	
			for( Index = 0; Index < 4; Index ++ )
			{
				if( Setting->DirectionalPadWayUsage[Index] < 8 )
				{
					X360C_SetSlider(
						 Slider
						,DirectionalPadWay_Slider[Index]
						,Setting->DirectionalPadWayUsage[Index]
						,Setting->DirectionalPadWayRapidFire[Index]
						,100
						,&DeviceExtension->DirectionalPadWayLastState[Index]
						,&DeviceExtension->DirectionalPadWayRapidFireCount[Index] );
				} else {
					X360C_SetButton(
						 &ButtonState
						,DirectionalPadWay_Button[Index]
						,Setting->DirectionalPadWayUsage[Index]
						,Setting->DirectionalPadWayRapidFire[Index]
						,100
						,&DeviceExtension->DirectionalPadWayLastState[Index]
						,&DeviceExtension->DirectionalPadWayRapidFireCount[Index] );
				}
			}
			break;
	}

	//	gK[
	for( Index = 0; Index < 2; Index ++ )
	{
		if( Setting->TriggerUsage[Index] < 8 )
		{
			X360C_SetSlider(
				 Slider
				,Trigger_Slider[Index]
				,Setting->TriggerUsage[Index]
				,Setting->TriggerRapidFire[Index]
				,100
				,&DeviceExtension->TriggerLastState[Index]
				,&DeviceExtension->TriggerRapidFireCount[Index] );
		} else {
			X360C_SetButton(
				 &ButtonState
				,Trigger_Button[Index]
				,Setting->TriggerUsage[Index]
				,Setting->TriggerRapidFire[Index]
				,100
				,&DeviceExtension->TriggerLastState[Index]
				,&DeviceExtension->TriggerRapidFireCount[Index] );
		}
	}

	//	{^
	for( Index = 0; Index < 11; Index ++ )
	{
		if( Setting->ButtonUsage[Index] < 8 )
		{
			X360C_SetSlider(
				 Slider
				,Button_Slider[Index]
				,Setting->ButtonUsage[Index]
				,Setting->ButtonRapidFire[Index]
				,Setting->ButtonRapidFireSpeed[Index]
				,&DeviceExtension->ButtonLastState[Index]
				,&DeviceExtension->ButtonRapidFireCount[Index] );
		} else {
			X360C_SetButton(
				 &ButtonState
				,Button_Button[Index]
				,Setting->ButtonUsage[Index]
				,Setting->ButtonRapidFire[Index]
				,Setting->ButtonRapidFireSpeed[Index]
				,&DeviceExtension->ButtonLastState[Index]
				,&DeviceExtension->ButtonRapidFireCount[Index] );
		}
	}

	//	XC_[̒l𒆐SɃXChH
	for( Index = 0; Index < 4; Index ++ )
	{
		if( Setting->SlideSliderValue[Index] != 0 )
		{
			if( Setting->ReverseSliderValue[Index] != 0 )
			{
				if( Setting->SlideCenterValue[Index] != 0 )
				{
					if( Slider[Index] >= 0 )
					{
						Slider[Index]	= 128 + Slider[Index] / 2;
					} else {
						Slider[Index]	= 128 + Slider[Index] / 2 - 1;
					}
				} else {
					if( Slider[Index] >= 0 )
					{
						Slider[Index]	= 127 + ( Slider[Index] ? Slider[Index] / 2 + 1: 0 );
					} else {
						Slider[Index]	= 127 + Slider[Index] / 2;
					}
				}
			} else {
				if( Setting->SlideCenterValue[Index] != 0 )
				{
					if( Slider[Index] >= 0 )
					{
						Slider[Index]	= 127 + ( Slider[Index] ? Slider[Index] / 2 + 1: 0 );
					} else {
						Slider[Index]	= 127 + Slider[Index] / 2;
					}
				} else {
					if( Slider[Index] >= 0 )
					{
						Slider[Index]	= 128 + Slider[Index] / 2;
					} else {
						Slider[Index]	= 128 + Slider[Index] / 2 - 1;
					}
				}
			}
		}
	}

	//	XC_[̒l𔽓]H
	for( Index = 0; Index < 4; Index ++ )
	{
		if( Setting->ReverseSliderValue[Index] != 0 )
		{
			Slider[Index]	= 255 - Slider[Index];
		}
	}

	//	X  / Y 
	Report->XAxis		= Axis[0];
	Report->YAxis		= Axis[1];

	//	X ] / Y ]
	Report->XRotation	= Axis[2];
	Report->YRotation	= Axis[3];

	//	Z  / Z ]
	Report->ZAxis		= (UCHAR)min( max( Slider[0], 0 ), 255 );
	Report->ZRotation	= (UCHAR)min( max( Slider[1], 0 ), 255 );

	//	XC_[ 1 ` 2
	Report->Slider1		= (UCHAR)min( max( Slider[2], 0 ), 255 );
	Report->Slider2		= (UCHAR)min( max( Slider[3], 0 ), 255 );

	//	nbg XCb` 1 ` 4
	Report->HatSwitch1	= HatSwitchArray[ HatSwitch[0] ];
	Report->HatSwitch2	= HatSwitchArray[ HatSwitch[1] ];
	Report->HatSwitch3	= HatSwitchArray[ HatSwitch[2] ];
	Report->HatSwitch4	= HatSwitchArray[ HatSwitch[3] ];

	//	{^ 1 ` 32
	Report->Button		= ButtonState;

	return( Status );
}

//----------------------------------------------------------------------------------------------
//	X360C_AdjustStick_Axis
//----------------------------------------------------------------------------------------------
VOID X360C_AdjustStick_Axis(
	 LONG		Mode
	,SHORT *	XAxisValue
	,SHORT *	YAxisValue
	,LONG		MinThreshold
	,LONG		MaxThreshold )
{
	//	ϐ錾
	LONG	WorkX		= *XAxisValue;
	LONG	WorkY		= *YAxisValue;
	LONG	Denominator	= ( MaxThreshold - MinThreshold ) * 32767 / 100;
	LONG	Length;
	LONG	Angle;

	switch( Mode )
	{
		case 0:
			//	㉺𔽓]
			WorkY	= min( 32767, ( WorkY == 32767 ? -32768 : -WorkY ) );

			//	臒lŒl̒S
			if( WorkX > 0 )
			{
				WorkX	= max( 0, WorkX - ( MinThreshold * 32767 / 100 ) );
			}
			if( WorkX < 0 )
			{
				WorkX	= min( 0, WorkX + ( MinThreshold * 32767 / 100 ) );
			}
			if( WorkY > 0 )
			{
				WorkY	= max( 0, WorkY - ( MinThreshold * 32767 / 100 ) );
			}
			if( WorkY < 0 )
			{
				WorkY	= min( 0, WorkY + ( MinThreshold * 32767 / 100 ) );
			}

			//	臒lōꂽlg傷
			if( Denominator != 0 )
			{
				WorkX	= WorkX * 32767 / Denominator;
				WorkY	= WorkY * 32767 / Denominator;
			} else {
				WorkX	= 0;
				WorkY	= 0;
			}

			//	l͈̔͂𒲐Al̏㉺
			WorkX	= min( 32767, max( -32768, WorkX ) );
			WorkY	= min( 32767, max( -32768, WorkY ) );
			break;

		case 1:
			//	S̋Ɗpx߂
			Length	= Sqrt( WorkX * WorkX + WorkY * WorkY );
			Angle	= ATan2( WorkY, WorkX );

			//	臒lŋ̒S
			if( Length > 0 )
			{
				Length	= max( 0, Length - ( MinThreshold * 32767 / 100 ) );
			}
			if( Length < 0 )
			{
				Length	= min( 0, Length + ( MinThreshold * 32767 / 100 ) );
			}

			//	臒lōꂽg傷
			if( Denominator != 0 )
			{
				Length	= Length * 32767 / Denominator;
			} else {
				Length	= 0;
			}

			//	͈̔͂𒲐Ȁ㉺
			Length	= min( 32767, max( -32768, Length ) );

			//	ƊpxW߂
			WorkX	= Length * Cos( Angle ) / 32767;
			if( WorkX == -32767 )
			{
				WorkX	= -32768;
			}
			WorkY	= Length * -Sin( Angle ) / 32767;
			if( WorkY == -32767 )
			{
				WorkY	= -32768;
			}
			break;
	}

	//	l߂
	*XAxisValue	= (SHORT)WorkX;
	*YAxisValue	= (SHORT)WorkY;
}

//----------------------------------------------------------------------------------------------
//	X360C_AdjustStick_HatSwitch
//----------------------------------------------------------------------------------------------
VOID X360C_AdjustStick_HatSwitch(
	 UCHAR *	HatSwitchValue
	,SHORT		XAxisValue
	,SHORT		YAxisValue
	,LONG		Threshold )
{
	//	ϐ錾
	LONG	Denominator	= Threshold * 32767 / 100;

	//	
	if( Denominator < YAxisValue  )
	{
		*HatSwitchValue	|= 0x01;
	}
	//	
	if( YAxisValue < ( -Denominator - 1 ) )
	{
		*HatSwitchValue	|= 0x02;
	}
	//	
	if( Denominator < XAxisValue  )
	{
		*HatSwitchValue	|= 0x08;
	}
	//	E
	if( XAxisValue < ( -Denominator - 1 ) )
	{
		*HatSwitchValue	|= 0x04;
	}
}

//----------------------------------------------------------------------------------------------
//	X360C_AdjustSlider_Slider
//----------------------------------------------------------------------------------------------
VOID X360C_AdjustSlider_Slider(
	 UCHAR *	SliderValue
	,LONG		MinThreshold
	,LONG		MaxThreshold )
{
	//	ϐ錾
	LONG	Work		= (LONG)*SliderValue;
	LONG	Denominator	= ( MaxThreshold - MinThreshold ) * 255 / 100;

	//	臒lŒl̉
	Work	= max( 0, Work - ( MinThreshold * 255 / 100 ) );

	//	臒lōꂽlg傷
	if( Denominator != 0 )
	{
		Work	= Work * 255 / Denominator;
	} else {
		Work	= 0;
	}

	//	l͈̔͂𒲐Al̏
	Work	= min( 255, max( 0, Work ) );

	//	l߂
	*SliderValue	= (UCHAR)Work;
}

//----------------------------------------------------------------------------------------------
//	X360C_AdjustSlider_Button
//----------------------------------------------------------------------------------------------
VOID X360C_AdjustSlider_Button(
	 ULONG *	ButtonValue
	,UCHAR		SliderValue
	,LONG		Threshold )
{
	//	ϐ錾
	LONG	Denominator	= Threshold * 255 / 100;

	//	{^
	if( Denominator < SliderValue  )
	{
		*ButtonValue	= 1;
	} else {
		*ButtonValue	= 0;
	}
}

//----------------------------------------------------------------------------------------------
//	X360C_SetAxisRotation
//----------------------------------------------------------------------------------------------
VOID X360C_SetAxisRotation(
	 SHORT *	Axis
	,SHORT		AxisXValue
	,SHORT		AxisYValue
	,ULONG		Usage
	,ULONG		Reverse )
{
	//	ϐ錾
	LONG	WorkX	= (LONG)AxisXValue;
	LONG	WorkY	= (LONG)AxisYValue;
	LONG	Current	= 0;

	//	㉺𔽓]
	if( Reverse != 0 )
	{
		WorkY	= min( 32767, ( WorkY == 32767 ? -32768 : -WorkY ) );
	}

#if( WINVER < 0x0500 )
	//	0 ` 65535 ɒl𒲐
	Current	= (USHORT)Axis[Usage * 2    ];
	if( Current != 32767 )
	{
		WorkX	= WorkX + ( Current - 32768 );
	}
	Current	= (USHORT)Axis[Usage * 2 + 1];
	if( Current != 32767 )
	{
		WorkY	= WorkY + ( Current - 32768 );
	}

	if( WorkX == 0 )
	{
		WorkX	= 32767;
	} else {
		WorkX	= WorkX + 32768;
	}
	if( WorkY == 0 )
	{
		WorkY	= 32767;
	} else {
		WorkY	= WorkY + 32768;
	}

	//	lZbg
	Axis[Usage * 2    ]	= (SHORT)min( 65535, max( 0, WorkX ) );
	Axis[Usage * 2 + 1]	= (SHORT)min( 65535, max( 0, WorkY ) );
#else
	//	lZbg
	Axis[Usage * 2    ]	= (SHORT)min( 32767, max( -32768, (LONG)Axis[Usage * 2    ] + WorkX ) );
	Axis[Usage * 2 + 1]	= (SHORT)min( 32767, max( -32768, (LONG)Axis[Usage * 2 + 1] + WorkY ) );
#endif
}

//----------------------------------------------------------------------------------------------
//	X360C_SetHatSwitch
//----------------------------------------------------------------------------------------------
VOID X360C_SetHatSwitch(
	 UCHAR *	HatSwitch
	,UCHAR		HatSwitchValue
	,ULONG		Usage
	,ULONG		Reverse )
{
	//	㉺𔽓]
	if( Reverse != 0 )
	{
		switch( HatSwitchValue & 0x03 )
		{
			case 0x01:
				HatSwitchValue	= ( HatSwitchValue & 0x0c ) | 0x02;
				break;

			case 0x02:
				HatSwitchValue	= ( HatSwitchValue & 0x0c ) | 0x01;
				break;
		}
	}

	//	lZbg
	HatSwitch[Usage - 14]	|= HatSwitchValue;
}

//----------------------------------------------------------------------------------------------
//	X360C_SetSlider
//----------------------------------------------------------------------------------------------
VOID X360C_SetSlider(
	 SHORT *	Slider
	,SHORT		SliderValue
	,ULONG		Usage
	,ULONG		RapidFire
	,ULONG		RapidFireRate
	,ULONG *	LastState
	,ULONG *	RapidFireCount )
{
	//	ϐ錾
	SHORT	Work	= (SHORT)SliderValue;
	LONG	Index	= Usage / 2;
	LONG	Type	= Usage % 2;

	//	lZbg
	//	A˂L̏ꍇ͑ȌԂ`FbN
	if( ( RapidFire == 0 ) || ( *LastState == 0 ) )
	{
		if( Work != 0 )
		{
			if( RapidFire == 0 )
			{
				if( Type == 0 )
				{
					Slider[Index]	= Slider[Index] + Work;
				} else {
					Slider[Index]	= Slider[Index] - Work;
				}
				*LastState	= 1;
			} else {
				if( ( *RapidFireCount >= 100 ) )
				{
					if( Type == 0 )
					{
						Slider[Index]	= Slider[Index] + Work;
					} else {
						Slider[Index]	= Slider[Index] - Work;
					}
					*LastState	= 1;
					*RapidFireCount	= *RapidFireCount - 100;
				}
				*RapidFireCount	= *RapidFireCount + RapidFireRate;
			}
		} else {
			*RapidFireCount	= 100;
			*LastState		= 0;
		}
	} else {
		*LastState	= 0;
	}
}

//----------------------------------------------------------------------------------------------
//	X360C_SetButton
//----------------------------------------------------------------------------------------------
VOID X360C_SetButton(
	 ULONG *	ButtonState
	,ULONG		ButtonValue
	,ULONG		Usage
	,ULONG		RapidFire
	,ULONG		RapidFireRate
	,ULONG *	LastState
	,ULONG *	RapidFireCount )
{
	//	蓖ĂȂ
	if( Usage >= 40 )
	{
		return;
	}

	//	A˂L̏ꍇ͑ȌԂ`FbN
	if( ( RapidFire == 0 ) || ( *LastState == 0 ) )
	{
		if( ButtonValue != 0 )
		{
			if( RapidFire == 0 )
			{
				*ButtonState	|= Button[ Usage - 8 ];
				*LastState		= 1;
			} else {
				if( ( *RapidFireCount >= 100 ) )
				{
					*ButtonState	|= Button[ Usage - 8 ];
					*LastState		= 1;

					*RapidFireCount	= *RapidFireCount - 100;
				}
				*RapidFireCount	= *RapidFireCount + RapidFireRate;
			}
		} else {
			*RapidFireCount	= 100;
			*LastState		= 0;
		}
	} else {
		*LastState	= 0;
	}
}

//----------------------------------------------------------------------------------------------
//	X360C_GenerateOutputReport
//----------------------------------------------------------------------------------------------
NTSTATUS X360C_GenerateOutputReport(
	 IN PDEVICE_EXTENSION	DeviceExtension
	,OUT UCHAR *			Report )
{
	//	ϐ錾
	NTSTATUS		Status			= STATUS_SUCCESS;
	POUTPUT_REPORT	OutputReport	= &DeviceExtension->OutputReport;
	SETTING *		Setting			= &DeviceExtension->Setting;

	//	WXgݒǂݍ
	if( DeviceExtension->ResetDevice == TRUE )
	{
		X360C_LoadSetting( DeviceExtension );
		DeviceExtension->ResetRingLight	= TRUE;
		DeviceExtension->ResetDevice	= FALSE;
	}

	//	tH[X tB[hobN
	if( Report[2] == 0 )
	{
		if( Setting->ForceFeedback == 1 )
		{
			//	AN`G[^
			X360C_SetActuator(
				 &OutputReport->Left
				,Report[0]
				,Setting->ActuatorLevel[0]
				,Setting->ActuatorMinThreshold
				,Setting->ActuatorMaxThreshold );

			//	EAN`G[^
			X360C_SetActuator(
				 &OutputReport->Right
				,Report[1]
				,Setting->ActuatorLevel[1]
				,Setting->ActuatorMinThreshold
				,Setting->ActuatorMaxThreshold );
		} else {
			OutputReport->Left	= 0;
			OutputReport->Right	= 0;
		}
	} else {
		OutputReport->Left	= Report[0];
		OutputReport->Right	= Report[1];
	}

	//	tOオĂ΃WXgeǂݒ
	if( Report[2] == 255 )
	{
		DeviceExtension->ResetDevice	= TRUE;
	}

	return( Status );
}

//----------------------------------------------------------------------------------------------
//	X360C_SetActuator
//----------------------------------------------------------------------------------------------
VOID X360C_SetActuator(
	 UCHAR *	ActuatorState
	,UCHAR		ActuatorValue
	,LONG		Level
	,LONG		MinThreshold
	,LONG		MaxThreshold )
{
	//	ϐ錾
	LONG	Work		= (LONG)ActuatorValue;
	LONG	MaxLevel	= ( Level * 255 / 100 );
	LONG	Denominator	= MaxThreshold * 255 / 100;

	//	l̑傫𒲐
	Work	= Work * Level / 100;

	//	臒lŐ؂̂Ă
	if( Work <= MinThreshold * ( Level * 255 / 100 ) / 100 )
	{
		Work	= 0;
	}

	//	臒lōꂽ͈͂g傷
	if( Denominator != 0 )
	{
		Work	= Work * 255 / Denominator;
	} else {
		Work	= 0;
	}

	//	l͈̔͂𒲐
	Work	= max( 0, min( MaxLevel, Work ) );

	//	lZbg
	*ActuatorState	= (UCHAR)Work;
}

//----------------------------------------------------------------------------------------------
//	X360C_LoadSetting
//----------------------------------------------------------------------------------------------
NTSTATUS X360C_LoadSetting( IN PDEVICE_EXTENSION DeviceExtension )
{
	//	ϐ錾
	NTSTATUS	Status	= STATUS_SUCCESS;
	LONG		Index;

	//	WXgǂ߂Ȃꍇ̏ݒs
	RtlZeroMemory( &DeviceExtension->Setting, sizeof( SETTING ) );

	//	XeBbN
	for( Index = 0; Index < 2; Index ++ )
	{
		DeviceExtension->Setting.StickUsage[Index]					= Index;
		DeviceExtension->Setting.StickReverse[Index]				= 0;
	}
	DeviceExtension->Setting.StickMinThreshold					= 15;
	DeviceExtension->Setting.StickMaxThreshold					= 95;
	DeviceExtension->Setting.StickHatSwitchThreshold			= 50;

	//	pbh
	DeviceExtension->Setting.DirectionalPadUsage				= 14;
	DeviceExtension->Setting.DirectionalPadReverse				= 0;
	for( Index = 0; Index < 4; Index ++ )
	{
		DeviceExtension->Setting.DirectionalPadWayUsage[Index]		= 20 + Index;
		DeviceExtension->Setting.DirectionalPadWayRapidFire[Index]	= 0;
	}

	//	gK[
	DeviceExtension->Setting.TriggerUsage[0]					= 18;
	DeviceExtension->Setting.TriggerRapidFire[0]				= 0;
	DeviceExtension->Setting.TriggerUsage[1]					= 19;
	DeviceExtension->Setting.TriggerRapidFire[1]				= 0;
	DeviceExtension->Setting.TriggerMinThreshold				= 15;
	DeviceExtension->Setting.TriggerMaxThreshold				= 95;
	DeviceExtension->Setting.TriggerButtonThreshold				= 85;

	//	{^
	for( Index = 0; Index < 10; Index ++ )
	{
		DeviceExtension->Setting.ButtonUsage[Index]					= 8 + Index;
		DeviceExtension->Setting.ButtonRapidFire[Index]				= 0;
		DeviceExtension->Setting.ButtonRapidFireSpeed[Index]		= 100;
	}
	DeviceExtension->Setting.ButtonUsage[10]					= 20;
	DeviceExtension->Setting.ButtonRapidFire[10]				= 0;
	DeviceExtension->Setting.ButtonRapidFireSpeed[10]			= 100;

	//	O Cg
	DeviceExtension->Setting.RingLightPattern					= 0;

	//	U
	DeviceExtension->Setting.ForceFeedback						= 1;
	DeviceExtension->Setting.ActuatorLevel[0]					= 80;
	DeviceExtension->Setting.ActuatorLevel[1]					= 80;
	DeviceExtension->Setting.ActuatorMinThreshold				= 20;
	DeviceExtension->Setting.ActuatorMaxThreshold				= 100;

	//	ڍאݒ
	DeviceExtension->Setting.StickDeadZoneType					= 0;
	for( Index = 0; Index < 2; Index ++ )
	{
		DeviceExtension->Setting.SlideSliderValue[Index]			= 1;
#if( WINVER < 0x0500 )
		DeviceExtension->Setting.SlideCenterValue[Index]			= 1;
#else
		DeviceExtension->Setting.SlideCenterValue[Index]			= 0;
#endif
		DeviceExtension->Setting.ReverseSliderValue[Index]			= 0;
	}
	for( Index = 2; Index < 4; Index ++ )
	{
		DeviceExtension->Setting.SlideSliderValue[Index]			= 0;
#if( WINVER < 0x0500 )
		DeviceExtension->Setting.SlideCenterValue[Index]			= 1;
#else
		DeviceExtension->Setting.SlideCenterValue[Index]			= 0;
#endif
		DeviceExtension->Setting.ReverseSliderValue[Index]			= 0;
	}
	DeviceExtension->Setting.LimitationMode						= 0;
	DeviceExtension->Setting.DevicesArePolled					= 1;
	DeviceExtension->Setting.ReduceOutputReport					= 0;

	//	WXgݒǂݍ
	GetRegistryBinary(
		 REGISTRY_PATH
		,CURRENT_SETTING
		,(char *)(&DeviceExtension->Setting)
		,sizeof( SETTING ) );

	//	|[OsȂꍇ͘Aˋ@\𖳌ɂ
	if( DevicesArePolled == FALSE )
	{
		for( Index = 0; Index < 11; Index ++ )
		{
			DeviceExtension->Setting.ButtonRapidFire[Index]				= 0;
		}
	}

	return( Status );
}
