
//	HID Minidriver for Microsoft Xbox 360 Controller

#include	"X360C.h"

//----------------------------------------------------------------------------------------------
//	IRP_MJ_POWER
//----------------------------------------------------------------------------------------------
NTSTATUS X360C_Power(
	 IN PDEVICE_OBJECT	DeviceObject
	,IN PIRP			Irp )
{
	//	ϐ錾
	NTSTATUS			Status			= STATUS_SUCCESS;
	PDEVICE_EXTENSION	DeviceExtension	= GET_MINIDRIVER_DEVICE_EXTENSION( DeviceObject );
	PIO_STACK_LOCATION	CurrentIrpStack;

	//	QƃJE^Z
	Status	= IncrementReference( DeviceExtension );
	if( !NT_SUCCESS( Status ) )
	{
		CompleteRequest( Irp, Status, 0 );
		return( Status );
	}

	CurrentIrpStack	= IoGetCurrentIrpStackLocation( Irp );
	switch( CurrentIrpStack->MinorFunction )
	{
		case IRP_MN_SET_POWER:
			switch( CurrentIrpStack->Parameters.Power.Type )
			{
				case SystemPowerState:
					if( CurrentIrpStack->Parameters.Power.State.SystemState
							== PowerSystemWorking )
					{
						//	O CgĐݒ肷
						DeviceExtension->ResetRingLight	= TRUE;
					}
				break;
			}
			break;
	}

	//	ʃhCo IRP_MJ_POWER v𑗂
	IoSkipCurrentIrpStackLocation( Irp );
	PoStartNextPowerIrp( Irp );
	Status	= PoCallDriver( GET_NEXT_DEVICE_OBJECT( DeviceObject ), Irp );

	//	QƃJE^Z
	DecrementReference( DeviceExtension );

	return( Status );
}
