
//	HID Minidriver for Microsoft Xbox 360 Controller

#include	"X360C.h"

//----------------------------------------------------------------------------------------------
//	O[oϐ
//----------------------------------------------------------------------------------------------

BOOLEAN	DevicesArePolled;
LONG	LimitationMode;

//----------------------------------------------------------------------------------------------
//	DriverEntry
//----------------------------------------------------------------------------------------------
NTSTATUS DriverEntry(
	 IN PDRIVER_OBJECT	DriverObject
	,IN PUNICODE_STRING	RegistryPath )
{
	//	ϐ錾
	NTSTATUS					Status	= STATUS_SUCCESS;
	SETTING						Setting;
	HID_MINIDRIVER_REGISTRATION	HIDMiniDriverRegistration;

	//	hCo Gg |Cgݒ肷
	DriverObject->DriverExtension->AddDevice					= X360C_AddDevice;
	DriverObject->DriverUnload									= X360C_Unload;
	DriverObject->MajorFunction[IRP_MJ_INTERNAL_DEVICE_CONTROL]	= X360C_InternalDeviceControl;
	DriverObject->MajorFunction[IRP_MJ_PNP]						= X360C_PnP;
	DriverObject->MajorFunction[IRP_MJ_POWER]					= X360C_Power;

	//	݊̐ݒ擾
	Setting.DevicesArePolled	= 1;
	Setting.LimitationMode		= 0;
	GetRegistryBinary( REGISTRY_PATH, CURRENT_SETTING, (char *)&Setting, sizeof( SETTING ) );
	DevicesArePolled	= (BOOLEAN)Setting.DevicesArePolled;
	LimitationMode		= min( Setting.LimitationMode, 3 );

	//	HID Minidriver o^
	RtlZeroMemory( &HIDMiniDriverRegistration, sizeof( HIDMiniDriverRegistration ) );
	HIDMiniDriverRegistration.Revision				= HID_REVISION;
	HIDMiniDriverRegistration.DriverObject			= DriverObject;
	HIDMiniDriverRegistration.RegistryPath			= RegistryPath;
	HIDMiniDriverRegistration.DeviceExtensionSize	= sizeof( DEVICE_EXTENSION );
	HIDMiniDriverRegistration.DevicesArePolled		= (BOOLEAN)DevicesArePolled;
	Status	= HidRegisterMinidriver( &HIDMiniDriverRegistration );

	return( Status );
}
