
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	O[oϐ錾
//----------------------------------------------------------------------------------------------

IClassFactoryVtbl	ClassFactoryVtbl	=
{
	 ClassFactory_QueryInterface
	,ClassFactory_AddRef
	,ClassFactory_Release
	,ClassFactory_CreateInstance
	,ClassFactory_LockServer
};

IClassFactory	ClassFactoryInterface	=
{
	&ClassFactoryVtbl
};

//----------------------------------------------------------------------------------------------
//	ClassFactory_New
//----------------------------------------------------------------------------------------------
STDMETHODIMP ClassFactory_New(
	 REFIID		InterfaceID
	,LPVOID *	Interface )
{
	//	g̃C^[tFCX擾
	return( ClassFactory_QueryInterface( &ClassFactoryInterface, InterfaceID, Interface ) );
}

//----------------------------------------------------------------------------------------------
//	ClassFactory_QueryInterface
//----------------------------------------------------------------------------------------------
STDMETHODIMP ClassFactory_QueryInterface(
	 IClassFactory *	ClassFactory
	,REFIID				InterfaceID
	,LPVOID *			Interface )
{
	//	ϐ錾
	HRESULT	Result	= S_OK;

	//	g̃C^[tFCXԂ
	if(	IsEqualIID( InterfaceID, &IID_IUnknown )
	||	IsEqualIID( InterfaceID, &IID_IClassFactory ) )
	{
		ClassFactory_AddRef( ClassFactory );
		*Interface	= ClassFactory;
	} else {
		*Interface	= NULL;
		Result		= E_NOINTERFACE;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	ClassFactory_AddRef
//----------------------------------------------------------------------------------------------
STDMETHODIMP_(ULONG) ClassFactory_AddRef( IClassFactory * ClassFactory )
{
	//	QƃJE^Z
	return( IncrementReference() );
}

//----------------------------------------------------------------------------------------------
//	ClassFactory_Release
//----------------------------------------------------------------------------------------------
STDMETHODIMP_(ULONG) ClassFactory_Release( IClassFactory * ClassFactory )
{
	//	QƃJE^Z
	return( DecrementReference() );
}

//----------------------------------------------------------------------------------------------
//	ClassFactory_CreateInstance
//----------------------------------------------------------------------------------------------
STDMETHODIMP ClassFactory_CreateInstance(
	 IClassFactory *	ClassFactory
	,IUnknown *			UnknownInterface
	,REFIID				InterfaceID
	,LPVOID *			Interface )
{
	//	ϐ錾
	HRESULT	Result	= S_OK;

	//	IDIGameCntrlPropSheet 쐬
	if( UnknownInterface == NULL )
	{
		Result	= PropSheet_New( InterfaceID, Interface );
	} else {
		Result	= CLASS_E_NOAGGREGATION;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	ClassFactory_LockServer
//----------------------------------------------------------------------------------------------
STDMETHODIMP ClassFactory_LockServer(
	 IClassFactory *	ClassFactory
	,BOOL				Lock )
{
	//	ϐ錾
	HRESULT	Result	= S_OK;

	//	QƃJE^
	if( Lock == TRUE )
	{
		IncrementReference();
	} else {
		DecrementReference();
	}

	return( Result );
}
