
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	GetSupportDeviceCount
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) GetSupportDeviceCount()
{
	//	ϐ錾
	DWORD	DeviceCount	= 0;

	//	T|[gĂRg[̐擾
	GetRegistry( &DeviceCount, REG_DWORD, sizeof( DeviceCount ), SUPPORT_DEVICE_COUNT );

	return( DeviceCount );
}

//----------------------------------------------------------------------------------------------
//	GetSupportDeviceList
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetSupportDeviceList(
	 ULONG * *	DeviceList
	,LONG		DeviceCount )
{
	//	ϐ錾
	LONG	DeviceIndex;
	_TCHAR	DeviceAttribute[MAX_PATH];

	//	T|[gĂRg[̃x_[hcAv_Nghc擾
	*DeviceList	= (ULONG *)LocalAlloc( LPTR, DeviceCount * sizeof( ULONG ) );
	for( DeviceIndex = 0; DeviceIndex < DeviceCount; DeviceIndex ++ )
	{
		_stprintf( DeviceAttribute, SUPPORT_DEVICE_ATTRIBUTE, DeviceIndex );
		GetRegistry(
			 &((*DeviceList)[DeviceIndex])
			,REG_DWORD
			,sizeof( ULONG )
			,DeviceAttribute );
	}
}

//----------------------------------------------------------------------------------------------
//	IoDevice
//----------------------------------------------------------------------------------------------
STDAPI_(void) IoDevice(
	 LONG			Mode
	,INPUT_REPORT *	InputReport
	,UCHAR			LeftActuatorLevel
	,UCHAR			RightActuatorLevel )
{
	//	ϐ錾
	GUID								GUID_HID;
	HDEVINFO							DevInfo;
	SP_INTERFACE_DEVICE_DATA			Interface;
	PSP_INTERFACE_DEVICE_DETAIL_DATA	Detail;
	BOOL								Result;
	HANDLE								hDevice;
	HIDD_ATTRIBUTES						HidAttribute;
	BYTE								Output[4];
	DWORD								Index;
	DWORD								ReqLen;
	UCHAR								Input[ sizeof( INPUT_REPORT ) + 1 ];
	INPUT_REPORT *						DstReport;
	BOOL								DeviceFound;
	ULONG								DeviceIndex;

	//	foCX NX̃nh擾
	HidD_GetHidGuid(&GUID_HID);
	DevInfo	= SetupDiGetClassDevs(
				 &GUID_HID
				,NULL
				,NULL
				,DIGCF_PRESENT | DIGCF_INTERFACEDEVICE );
	if( DevInfo == INVALID_HANDLE_VALUE )
	{
		return;
	}

	//	Ώۂ̃C^[tFCXT
	Index	= 0;
	while( TRUE )
	{
		//	C^[tFCX擾
		Interface.cbSize	= sizeof( Interface );
		if( !SetupDiEnumDeviceInterfaces( DevInfo, NULL, &GUID_HID, Index, &Interface ) )
		{
			SetupDiDestroyDeviceInfoList( DevInfo );
			return;
		}

		//	C^[tFCX̏ڍ׏̃TCY擾
		SetupDiGetDeviceInterfaceDetail( DevInfo, &Interface, NULL, 0, &ReqLen, NULL );

		//	C^[tFCX̏ڍ׏擾
		Detail	= (PSP_INTERFACE_DEVICE_DETAIL_DATA)LocalAlloc( LPTR, ReqLen );
		if( Detail == NULL )
		{
			return;
		}
		Detail->cbSize	= sizeof( SP_INTERFACE_DEVICE_DETAIL_DATA );
		Result	= SetupDiGetDeviceInterfaceDetail(
					 DevInfo
					,&Interface
					,Detail
					,ReqLen
					,NULL
					,NULL );
		if( !Result )
		{
			SetupDiDestroyDeviceInfoList( DevInfo );
			LocalFree( Detail );
			return;
		}

		//	foCX C^[tFCXJ
		hDevice	= CreateFile(
					 Detail->DevicePath
					,GENERIC_READ | GENERIC_WRITE
					,FILE_SHARE_READ | FILE_SHARE_WRITE
					,NULL
					,OPEN_EXISTING
					,FILE_ATTRIBUTE_NORMAL
					,NULL );
		if( hDevice == INVALID_HANDLE_VALUE )
		{
			LocalFree( Detail );
			Index	++;
			continue;
		}

		//	C^[tFCX̏ڍׂɃx_R[hAv_NgR[h܂܂邩`FbN
		HidD_GetAttributes( hDevice, &HidAttribute );
		DeviceFound	= FALSE;
		for( DeviceIndex = 0; DeviceIndex < SupportDeviceCount; DeviceIndex ++ )
		{
			if(	HidAttribute.VendorID  == HIWORD( SupportDeviceAttribute[DeviceIndex] )
			&&	HidAttribute.ProductID == LOWORD( SupportDeviceAttribute[DeviceIndex] ) )
			{
				DeviceFound	= TRUE;
				break;
			}
		}
		if( DeviceFound == TRUE )
		{
			switch( Mode )
			{
				case APPLY_DEVICE:
					//	foCXփWXgǂݒ悤Ɏw
					Output[0]	= 0;
					Output[1]	= 0;
					Output[2]	= 0;
					Output[3]	= 255;
					WriteFile( hDevice, Output, sizeof( Output ), &ReqLen, NULL );
					break;

				case IN_REPORT:
					//	Rg[̐f[^擾
					ZeroMemory( Input, sizeof( Input ) );
					Result	= HidD_GetFeature( hDevice, Input, sizeof( Input ) );
					if( Result )
					{
						DstReport	= (INPUT_REPORT *)&Input[1];
						//	Rg[ɑΏ邽߁Af[^ZĂ
						//	fW^ {^
						InputReport->DigitalButton	|= DstReport->DigitalButton;
						//	gK[
						InputReport->LeftTrigger	= (UCHAR)min( 255, (LONG)InputReport->LeftTrigger + (LONG)DstReport->LeftTrigger );
						//	EgK[
						InputReport->RightTrigger	= (UCHAR)min( 255, (LONG)InputReport->RightTrigger + (LONG)DstReport->RightTrigger );
						//	XeBbN X
						InputReport->LeftStickX		= (SHORT)min( 32767, max( -32768, (LONG)InputReport->LeftStickX + (LONG)DstReport->LeftStickX ) );
						//	XeBbN Y
						InputReport->LeftStickY		= (SHORT)min( 32767, max( -32768, (LONG)InputReport->LeftStickY + (LONG)DstReport->LeftStickY ) );
						//	XeBbN X
						InputReport->RightStickX	= (SHORT)min( 32767, max( -32768, (LONG)InputReport->RightStickX + (LONG)DstReport->RightStickX ) );
						//	XeBbN Y
						InputReport->RightStickY	= (SHORT)min( 32767, max( -32768, (LONG)InputReport->RightStickY + (LONG)DstReport->RightStickY ) );
					}
					break;

				case OUT_REPORT:
					//	Űo
					Output[0]	= 0;
					Output[1]	= LeftActuatorLevel;
					Output[2]	= RightActuatorLevel;
					Output[3]	= 128;
					WriteFile( hDevice, Output, sizeof( Output ), &ReqLen, NULL );
					break;
			}
		}

		//	foCX C^[tFCX
		CloseHandle( hDevice );

		//	̃C^[tFCX
		LocalFree( Detail );
		Index	++;
	}

	//	foCX NX̃nhJ
	SetupDiDestroyDeviceInfoList( DevInfo );
}
