
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	DialogProc
//----------------------------------------------------------------------------------------------
LRESULT CALLBACK DialogProc(
	 HWND	Wnd
	,UINT	Message
	,WPARAM	wParam
	,LPARAM	lParam )
{
	//	ϐ錾
	INT_PTR	Result	= FALSE;

	//	bZ[WɂďU蕪
	switch( Message )
	{
		case WM_INITDIALOG:
			Result	= WM_InitDialog8( Wnd );
			break;

		case WM_COMMAND:
			Result	= WM_Command8( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_INITDIALOG
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_InitDialog8( HWND Wnd )
{
	//	ϐ錾
	INT_PTR	Result		= 0;
	HWND	ComboBox	= GetDlgItem(
							 PropSheet_IndexToHwnd( GetParent( Wnd ), 0 )
							,IDC_SETTING_LIST );
	_TCHAR	SettingName[MAX_PATH];

	//	IĂݒ薼̂擾AlƂĎgp
	if( ModifiedFlag == FALSE )
	{
		SendMessage( ComboBox, CB_GETLBTEXT, CurrentSettingIndex, (LPARAM)SettingName );
	} else {
		SendMessage( ComboBox, CB_GETLBTEXT, CurrentSettingIndex + 1, (LPARAM)SettingName );
	}
	SetWindowText( GetDlgItem( Wnd, IDC_SETTING_NAME ), SettingName );

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_COMMAND
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_Command8(
	 HWND	Wnd
	,WORD	NotifyMessage
	,WORD	ControlID
	,HWND	Control )
{
	//	ϐ錾
	INT_PTR	Result	= 0;
	_TCHAR	SettingName[MAX_PATH];

	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_SETTING_NAME:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case EN_CHANGE:
					//	ݒ̖̂̏ꍇ OK {^𖳌ɂ
					GetWindowText( Control, SettingName, sizeof( SettingName ) );
					if( _tcslen( SettingName ) > 0 )
					{
						EnableWindow( GetDlgItem( Wnd, IDOK ), TRUE );
					} else {
						EnableWindow( GetDlgItem( Wnd, IDOK ), FALSE );
					}
					break;
			}
			break;

		case IDOK:
			//	ݒۑ
			if( ClickOK( Wnd ) == TRUE )
			{
				EndDialog( Wnd, IDCANCEL );
			}
			break;

		case IDCANCEL:
			//	_CAO
			EndDialog( Wnd, IDCANCEL );
			break;

	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	ClickOK
//----------------------------------------------------------------------------------------------
STDAPI_(BOOL) ClickOK( HWND Wnd )
{
	//	ϐ錾
	_TCHAR	SettingName[MAX_PATH];
	_TCHAR	DstSettingName[MAX_PATH];
	LONG	SettingIndex;
	BOOL	DuplicateFlag	= FALSE;
	LONG	MsgResult;

	//	͂ꂽݒ薼̂擾
	GetWindowText( GetDlgItem( Wnd, IDC_SETTING_NAME ), SettingName, sizeof( SettingName ) );

	//	uW̐ݒvƏd邩`FbN
	LoadString( Instance, IDS_DEFAULT_SETTING, DstSettingName, sizeof( DstSettingName ) );
	if( _tcscmp( SettingName, DstSettingName ) == 0 )
	{
		ShowMessageBoxPlus(
			 Wnd
			,IDS_WARNING_TITLE
			,IDS_WARNING_MESSAGE
			,SettingName
			,MB_OK | MB_ICONINFORMATION );
		return( FALSE );
	}

	//	̐ݒ薼̂Əd邩`FbN
	for( SettingIndex = 1; SettingIndex < GetSettingCount(); SettingIndex ++ )
	{
		GetSettingName( DstSettingName, sizeof( DstSettingName ), SettingIndex );
		if( _tcscmp( SettingName, DstSettingName ) == 0 )
		{
			DuplicateFlag	= TRUE;
			break;
		}
	}
	if( DuplicateFlag == FALSE )
	{
		//	͂ꂽݒ薼̂Őݒۑ
		SaveNewSetting( Wnd );
		return( TRUE );
	} else {
		//	_CAO\ď㏑mF
		MsgResult	= ShowMessageBoxPlus(
						 Wnd
						,IDS_REPLACE_TITLE
						,IDS_REPLACE_MESSAGE
						,SettingName
						,MB_YESNO | MB_ICONQUESTION );
		if( MsgResult == IDYES )
		{
			ReplaceSetting( Wnd, SettingIndex );
			return( TRUE );
		}
	}
	return( FALSE );
}

//----------------------------------------------------------------------------------------------
//	SaveNewSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) SaveNewSetting( HWND Wnd )
{
	//	ϐ錾
	DWORD	SettingCount;
	_TCHAR	SettingName[MAX_PATH];
	HWND	PropSheet	= PropSheet_IndexToHwnd( GetParent( Wnd ), CONTROLLER );

	//	Rg[̐ݒ̐擾
	SettingCount	= GetSettingCount();

	//	Rg[̐ݒۑ
	GetDialogSetting( Wnd, &CurrentSetting );
	SetSetting( &CurrentSetting, SettingCount );

	//	Rg[̐ݒ̖̂ۑ
	GetWindowText( GetDlgItem( Wnd, IDC_SETTING_NAME ), SettingName, sizeof( SettingName ) );
	SetSettingName( SettingName, SettingCount );

	//	Rg[̐ݒ̐ۑ
	SetSettingCount( SettingCount + 1 );

	//	ݒ胊Xg̓eXVAۑݒI
	ModifiedFlag	= FALSE;
	InitSettingList( PropSheet, IDC_SETTING_LIST );
	SendMessage( GetDlgItem( PropSheet, IDC_SETTING_LIST ), CB_SETCURSEL, SettingCount, 0 );
	ChangeCurrentSetting( PropSheet );
}

//----------------------------------------------------------------------------------------------
//	ReplaceSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) ReplaceSetting(
	HWND	Wnd,
	LONG	SettingIndex )
{
	//	ϐ錾
	HWND	PropSheet	= PropSheet_IndexToHwnd( GetParent( Wnd ), CONTROLLER );

	//	Rg[̐ݒ㏑
	GetDialogSetting( Wnd, &CurrentSetting );
	SetSetting( &CurrentSetting, SettingIndex );

	//	ݒ胊Xg̓eXVAۑݒI
	ModifiedFlag	= FALSE;
	InitSettingList( PropSheet, IDC_SETTING_LIST );
	SendMessage( GetDlgItem( PropSheet, IDC_SETTING_LIST ), CB_SETCURSEL, SettingIndex, 0 );
	ChangeCurrentSetting( PropSheet );
}
