
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	O[oϐ
//----------------------------------------------------------------------------------------------

SETTING	CurrentSetting;
LONG	CurrentSettingIndex;

BOOL	ModifiedFlag;

ULONG	SupportDeviceCount;
ULONG *	SupportDeviceAttribute;

HANDLE	Mutex;

BOOL	DeleteFlag;

//----------------------------------------------------------------------------------------------
//	PageProc1
//----------------------------------------------------------------------------------------------
INT_PTR CALLBACK PageProc1(
	 HWND	Wnd
	,UINT	Message
	,WPARAM	wParam
	,LPARAM	lParam )
{
	//	ϐ錾
	INT_PTR	Result	= FALSE;

	//	bZ[WɂďU蕪
	switch( Message )
	{
		case WM_INITDIALOG:
			Result	= WM_InitDialog1( Wnd );
			break;

		case WM_COMMAND:
			Result	= WM_Command1( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

		case WM_NOTIFY:
			Result	= WM_Notify1( Wnd, (int)wParam, (NMHDR *)lParam );
			break;

		case WM_TIMER:
			Result	= WM_Timer1( Wnd );
			break;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_INITDIALOG
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_InitDialog1( HWND Wnd )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	Xe[^X GAƂ̔rs
	Mutex	= CreateMutex( NULL, TRUE, X360CCP_MUTEX_NAME );

	//	O[oϐ
	GetDefaultSetting( &CurrentSetting );
	CurrentSettingIndex		= 0;
	ModifiedFlag			= FALSE;
	SupportDeviceCount		= 0;
	SupportDeviceAttribute	= NULL;

	//	WXg茻݂̐ݒ擾
	GetCurrentSetting( &CurrentSetting );
	CurrentSettingIndex		= GetCurrentSettingIndex();
	ModifiedFlag			= GetModifiedFlag();
	SupportDeviceCount		= GetSupportDeviceCount();
	GetSupportDeviceList( &SupportDeviceAttribute, SupportDeviceCount );

	//	uRg[̐ݒv
	InitSettingList( Wnd, IDC_SETTING_LIST );
	if( ModifiedFlag == FALSE )
	{
		SendMessage( GetDlgItem( Wnd, IDC_SETTING_LIST ), CB_SETCURSEL, CurrentSettingIndex, 0 );
	} else {
		SendMessage( GetDlgItem( Wnd, IDC_SETTING_LIST ), CB_SETCURSEL, 0, 0 );
	}
	if( ModifiedFlag == FALSE && CurrentSettingIndex > 0 )
	{
		EnableWindow( GetDlgItem( Wnd, IDC_SETTING_DELETE ), TRUE );
	} else {
		EnableWindow( GetDlgItem( Wnd, IDC_SETTING_DELETE ), FALSE );
	}

	//	uUv
	InitTrackBar( Wnd, IDC_FORCE_FEEDBACK_TEST, 0, 100, 10, 10 );

	//	|[Op^C}[N
	SetTimer( Wnd, POLLING_TIMER_ID, POLLING_INTERVAL, NULL );

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_COMMAND
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_Command1(
	 HWND	Wnd
	,WORD	NotifyMessage
	,WORD	ControlID
	,HWND	Control )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_SETTING_LIST:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					SelectSettingList( Wnd, Control );
					break;
			}
			break;

		case IDC_SETTING_SAVE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	Rg[̐ݒۑ
					DialogBox(
						 Instance
						,MAKEINTRESOURCE( IDD_SETTING_SAVE )
						,Wnd
						,(DLGPROC)DialogProc );
					break;
			}
			break;

		case IDC_SETTING_DELETE:
			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	IĂRg[̐ݒ폜
					DeleteSettingList( Wnd );
					break;
			}
			break;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_NOTIFY
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_Notify1(
	 HWND		Wnd
	,LONG		Id
	,NMHDR *	Notify )
{
	//	ϐ錾
	INT_PTR	Result	= 0;
	SETTING	PrevSetting;

	//	ʒmbZ[WɂďU蕪
	switch( Notify->code )
	{
		case PSN_APPLY:
			//	WXg茻݂̐ݒ擾
			GetDefaultSetting( &PrevSetting );
			GetCurrentSetting( &PrevSetting );

			//	WXgɌ݂̐ݒۑ
			GetDialogSetting( Wnd, &CurrentSetting );
			SetCurrentSetting( &CurrentSetting );
			SetCurrentSettingIndex( CurrentSettingIndex );
			SetModifiedFlag( ModifiedFlag );

			//	݊̐ݒ肪ςĂ΃_CAO\
			if( ( PrevSetting.DevicesArePolled	!= CurrentSetting.DevicesArePolled )
			||	( PrevSetting.LimitationMode	!= CurrentSetting.LimitationMode ) )
			{
				ShowMessageBox(
					 Wnd
					,IDS_RESTART_TITLE
					,IDS_RESTART_MESSAGE
					,MB_OK | MB_ICONINFORMATION );
			}

			//	foCXɔf
			IoDevice( APPLY_DEVICE, NULL, 0, 0 );
			Result	= PSNRET_NOERROR;

			//	vpeB V[gƂ̓~[ebNXJ
			if( ((PSHNOTIFY *)Notify)->lParam == TRUE )
			{
				CloseHandle( Mutex );
			}

			DeleteFlag	= FALSE;
			break;

		case PSN_RESET:
			//	ݒ폜ł΁AW̐ݒ iύXς݁jɂ
			if( DeleteFlag == TRUE )
			{
				SetCurrentSettingIndex( 0 );
				SetModifiedFlag( TRUE );
			}

			//	|[Op^C}[~
			KillTimer( Wnd, POLLING_TIMER_ID );

			//	Rg[̐U~߂
			IoDevice( OUT_REPORT, NULL, 0, 0 );

			//	vpeB V[gƂ̓~[ebNXJ
			CloseHandle( Mutex );
			break;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_TIMER
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_Timer1( HWND Wnd )
{
	//	ϐ錾
	INT_PTR			Result	= 0;
	SETTING			Setting;
	INPUT_REPORT	InputReport;
	REPORT			Report;
	LONG			TestLevel;
	UCHAR			ActuatorLevel[2];

	//	|[Op^C}[~
	KillTimer( Wnd, POLLING_TIMER_ID );

	//	݂̃Rg[̐ݒ擾
	Setting	= CurrentSetting;
	GetDialogSetting( Wnd, &Setting );

	//	U𐶐
	if( Setting.ForceFeedback == TRUE )
	{
		TestLevel	= (LONG)SendMessage(
						 GetDlgItem( Wnd, IDC_FORCE_FEEDBACK_TEST )
						,TBM_GETPOS
						,0
						,0 ) * 255 / 100;
		X360C_SetActuator(
			 &ActuatorLevel[0]
			,(UCHAR)TestLevel
			,Setting.ActuatorLevel[0]
			,Setting.ActuatorMinThreshold
			,Setting.ActuatorMaxThreshold );
		X360C_SetActuator(
			 &ActuatorLevel[1]
			,(UCHAR)TestLevel
			,Setting.ActuatorLevel[1]
			,Setting.ActuatorMinThreshold
			,Setting.ActuatorMaxThreshold );
	} else {
		ActuatorLevel[0]	= 0;
		ActuatorLevel[1]	= 0;
	}
	IoDevice( OUT_REPORT, NULL, ActuatorLevel[0], ActuatorLevel[1] );

	//	Rg[̏Ԃ𐶐
	ZeroMemory( &InputReport, sizeof( InputReport ) );
	IoDevice( IN_REPORT, &InputReport, 0, 0 );
	X360C_GenerateInputReport( &InputReport, &Setting, &Report );

	//	ꂽRg[̏Ԃ\
	UpdateWindowText( Wnd, IDC_X_AXIS, Report.XAxis );
	UpdateWindowText( Wnd, IDC_Y_AXIS, Report.YAxis );
	UpdateWindowText( Wnd, IDC_X_ROTATION, Report.XRotation );
	UpdateWindowText( Wnd, IDC_Y_ROTATION, Report.YRotation );
	UpdateWindowText( Wnd, IDC_Z_AXIS, Report.ZAxis );
	UpdateWindowText( Wnd, IDC_Z_ROTATION, Report.ZRotation );
	UpdateWindowText( Wnd, IDC_SLIDER1, Report.Slider1 );
	UpdateWindowText( Wnd, IDC_SLIDER2, Report.Slider2 );
	UpdateWindowText(
		 Wnd
		,IDC_HAT_SWITCH1
		,Report.HatSwitch1 != -1 ? Report.HatSwitch1 * 45 : -1 );
	UpdateWindowText(
		 Wnd
		,IDC_HAT_SWITCH2
		,Report.HatSwitch2 != -1 ? Report.HatSwitch2 * 45 : -1 );
	UpdateWindowText(
		 Wnd
		,IDC_HAT_SWITCH3
		,Report.HatSwitch3 != -1 ? Report.HatSwitch3 * 45 : -1 );
	UpdateWindowText(
		 Wnd
		,IDC_HAT_SWITCH4
		,Report.HatSwitch4 != -1 ? Report.HatSwitch4 * 45 : -1 );
	UpdateWindowTextPlus( Wnd, IDC_BUTTON, Report.Button );

	//	|[Op^C}[Jn
	SetTimer( Wnd, POLLING_TIMER_ID, POLLING_INTERVAL, NULL );

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	InitSettingList
//----------------------------------------------------------------------------------------------
STDAPI_(void) InitSettingList(
	 HWND	Wnd
	,ULONG	ComboBoxID )
{
	//	ϐ錾
	HWND	ComboBox	= GetDlgItem( Wnd, ComboBoxID );
	_TCHAR	SettingName[MAX_PATH];
	_TCHAR	Modified[MAX_PATH];
	LONG	Start		= 1;
	LONG	End			= GetSettingCount();
	LONG	Index;

	//	R{ {bNX̓eZbg
	SendMessage( ComboBox, CB_RESETCONTENT, 0, 0 );

	//	uW̐ݒvR{ {bNXɑ}
	LoadString( Instance, IDS_DEFAULT_SETTING, SettingName, sizeof( SettingName ) );
	SendMessage( ComboBox, CB_INSERTSTRING, 0, (LPARAM)SettingName );

	//	WXgݒ薼̂擾AR{ {bNXɑ}
	for( Index = Start; Index < End; Index ++ )
	{
		GetSettingName( SettingName, sizeof( SettingName ), Index );
		SendMessage( ComboBox, CB_INSERTSTRING, Index, (LPARAM)SettingName );
	}

	//	ύXς݂ȂԏɁu` (ύXς)vǉ
	if( ModifiedFlag != FALSE )
	{
		//	R{ {bNX̐ݒ薼̂擾
		SendMessage( ComboBox, CB_GETLBTEXT, CurrentSettingIndex, (LPARAM)SettingName );

		//	\[Xu(ύXς)v擾Aݒ薼̂ɕt
		LoadString( Instance, IDS_MODIFIED, Modified, sizeof( Modified ) );
		_tcscat( SettingName, Modified );

		//	ύXς݂̐ݒ薼̂R{ {bNẌԏɑ}
		SendMessage( ComboBox, CB_INSERTSTRING, 0, (LPARAM)SettingName );
	}
}

//----------------------------------------------------------------------------------------------
//	SelectSettingList
//----------------------------------------------------------------------------------------------
STDAPI_(void) SelectSettingList(
	 HWND	Wnd
	,HWND	ComboBox )
{
	//	ϐ錾
	LONG	MsgResult;

	//	ύXς݂ǂŏU蕪
	if( ModifiedFlag != FALSE )
	{
		//	ԂIȂ牽Ȃ
		if( SendMessage( ComboBox, CB_GETCURSEL, 0, 0 ) == 0 )
		{
			return;
		}

		//	_CAO\AU蕪
		MsgResult	= ShowMessageBox(
						 Wnd
						,IDS_SAVE_TITLE
						,IDS_SAVE_MESSAGE
						,MB_YESNOCANCEL | MB_ICONQUESTION );
		switch( MsgResult )
		{
			case IDYES:
				//	Rg[̐ݒۑ
				MsgResult	= (LONG)DialogBox(
								 Instance
								,MAKEINTRESOURCE( IDD_SETTING_SAVE )
								,Wnd
								,(DLGPROC)DialogProc );
				if( MsgResult == IDCANCEL )
				{
					//	LZȂRg[̐ݒ 0 ɖ߂
					SendMessage( ComboBox, CB_SETCURSEL, 0, 0 );
				}
				break;

			case IDNO:
				//	ύXς݂폜ARg[̐ݒύX
				SendMessage( ComboBox, CB_DELETESTRING, 0, 0 );
				ChangeCurrentSetting( Wnd );
				break;

			case IDCANCEL:
				//	LZȂRg[̐ݒ 0 ɖ߂
				SendMessage( ComboBox, CB_SETCURSEL, 0, 0 );
				break;
		}
	} else {
		//	Rg[̐ݒύX
		ChangeCurrentSetting( Wnd );
	}
}

//----------------------------------------------------------------------------------------------
//	DeleteSettingList
//----------------------------------------------------------------------------------------------
STDAPI_(void) DeleteSettingList( HWND Wnd )
{
	//	ϐ錾
	HWND	ComboBox	= GetDlgItem( Wnd, IDC_SETTING_LIST );
	int		MsgResult;
	DWORD	SettingCount;
	_TCHAR	SettingName[MAX_PATH];
	SETTING	Setting;
	DWORD	Index;

	//	IĂݒ薼̂擾
	SendMessage(
		 ComboBox
		,CB_GETLBTEXT
		,CurrentSettingIndex
		,(LPARAM)SettingName );

	//	_CAO\č폜mF
	MsgResult	= ShowMessageBoxPlus(
					 Wnd
					,IDS_DELETE_TITLE
					,IDS_DELETE_MESSAGE
					,SettingName
					,MB_YESNO | MB_ICONQUESTION );
	if( MsgResult == IDYES )
	{
		//	ݒPXCh
		SettingCount	= GetSettingCount();
		for( Index = CurrentSettingIndex; Index < SettingCount - 1; Index ++ )
		{
			GetSetting( &Setting, Index + 1 );
			SetSetting( &Setting, Index );
			GetSettingName( SettingName, sizeof( SettingName ), Index + 1 );
			SetSettingName( SettingName, Index );
		}

		//	Ō̐ݒ폜Aݒ̐P炷
		DelSetting( SettingCount - 1 );
		DelSettingName( SettingCount - 1 );
		SetSettingCount( SettingCount - 1 );

		//	ݒ胊Xg̓eXVAP̐ݒI
		ModifiedFlag	= FALSE;
		InitSettingList( Wnd, IDC_SETTING_LIST );
		SendMessage( ComboBox, CB_SETCURSEL, CurrentSettingIndex - 1, 0 );
		ChangeCurrentSetting( Wnd );

		DeleteFlag	= TRUE;
	}
}

//----------------------------------------------------------------------------------------------
//	ChangeCurrentSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) ChangeCurrentSetting( HWND Wnd )
{
	//	ϐ錾
	LONG	CurSel;

	//	Rg[̐ݒőIĂ鏇Ԃ擾
	CurSel	= (LONG)SendMessage( GetDlgItem( Wnd, IDC_SETTING_LIST ), CB_GETCURSEL, 0, 0 );

	//	Rg[̐ݒŕWIĂ΁Au폜v𖳌ɂ
	if( CurSel == 0 )
	{
		EnableWindow( GetDlgItem( Wnd, IDC_SETTING_DELETE ), FALSE );
	} else {
		EnableWindow( GetDlgItem( Wnd, IDC_SETTING_DELETE ), TRUE );
	}

	//	ԂIȂ牽Ȃ
	if( ( ModifiedFlag == FALSE ) && ( CurSel == CurrentSettingIndex ) )
	{
		return;
	}

	//	Rg[̐ݒőIꂽݒ擾A_CAOɔf
	GetSetting( &CurrentSetting, CurSel );
	CurrentSettingIndex	= CurSel;
	ModifiedFlag		= FALSE;
	SetDialogSetting( Wnd, &CurrentSetting );

	//	vpeB V[gɕύXʒm
	PropSheet_Changed( GetParent( Wnd ), Wnd );
}
