
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	PageProc4
//----------------------------------------------------------------------------------------------
INT_PTR CALLBACK PageProc4(
	 HWND	Wnd
	,UINT	Message
	,WPARAM	wParam
	,LPARAM	lParam )
{
	//	ϐ錾
	INT_PTR	Result	= FALSE;

	//	bZ[WɂďU蕪
	switch( Message )
	{
		case WM_INITDIALOG:
			Result	= WM_InitDialog4( Wnd );
			break;

		case WM_COMMAND:
			Result	= WM_Command4( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

		case WM_HSCROLL:
			Result	= WM_HScroll4( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_INITDIALOG
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_InitDialog4( HWND Wnd )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	ugK[̋@\v
	InitComboBox( Wnd, IDC_LEFT_TRIGGER_USAGE, STRAIGHT );

	//	uEgK[̋@\v
	InitComboBox( Wnd, IDC_RIGHT_TRIGGER_USAGE, STRAIGHT );

	//	uĹ͈v
	InitTrackBar( Wnd, IDC_TRIGGER_DEAD_ZONE, 0, 100, 10, 10 );

	//	ugK[̓臒lv
	InitTrackBar( Wnd, IDC_TRIGGER_THRESHOLD, 0, 100, 10, 10 );

	//	IĂݒ_CAOɔf
	SetPageSetting4( Wnd, &CurrentSetting );

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_COMMAND
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_Command4(
	 HWND	Wnd
	,WORD	NotifyMessage
	,WORD	ControlID
	,HWND	Control )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_LEFT_TRIGGER_USAGE:
		case IDC_RIGHT_TRIGGER_USAGE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case CBN_SELCHANGE:
					//	`FbN {bNX̗LE؂ւ
					SelectComboBox( Control, Wnd, ControlID + 1, STRAIGHT );

					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;

		case IDC_LEFT_TRIGGER_RAPID_FIRE:
		case IDC_RIGHT_TRIGGER_RAPID_FIRE:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_HSCROLL
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_HScroll4(
	 HWND	Wnd
	,WORD	Value
	,WORD	Request
	,HWND	Control )
{
	//	ϐ錾
			INT_PTR	Result	= 0;
	static	BOOL	Selecting;

	//	uĹ͈ṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_TRIGGER_DEAD_ZONE ) )
	{
		if( SelectTrackBar( Control, Request, &Selecting ) == TRUE )
		{
			//	vpeB V[gɕύXʒm
			NotifyChange( Wnd );
		}
	}

	//	ugK[̓臒lṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_TRIGGER_THRESHOLD ) )
	{
		//	vpeB V[gɕύXʒm
		NotifyChange( Wnd );
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	SetPageSetting4
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetPageSetting4(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	LONG	Index;

	//	ugK[̋@\v
	for( Index = 0; Index < 2; Index ++ )
	{
		SetComboBox(
			 Wnd
			,IDC_LEFT_TRIGGER_USAGE + ( Index * 2 )
			,Setting->TriggerUsage[Index]
			,IDC_LEFT_TRIGGER_RAPID_FIRE + ( Index * 2 )
			,STRAIGHT );
		SetCheckBox(
			 Wnd
			,IDC_LEFT_TRIGGER_RAPID_FIRE + ( Index * 2 )
			,Setting->TriggerRapidFire[Index] );
	}

	//	uڍאݒv
	SetTrackBarRange(
		 Wnd
		,IDC_TRIGGER_DEAD_ZONE
		,Setting->TriggerMinThreshold
		,Setting->TriggerMaxThreshold );
	SetTrackBarPos( Wnd, IDC_TRIGGER_DEAD_ZONE, Setting->TriggerMinThreshold );
	SetTrackBarPos( Wnd, IDC_TRIGGER_THRESHOLD, Setting->TriggerButtonThreshold );
}

//----------------------------------------------------------------------------------------------
//	GetPageSetting4
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetPageSetting4(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	ϐ錾
	LONG	Index;

	//	ugK[̋@\v
	for( Index = 0; Index < 2; Index ++ )
	{
		Setting->TriggerUsage[Index]		= GetComboBox(
												 Wnd
												,IDC_LEFT_TRIGGER_USAGE + ( Index * 2 ) );
		Setting->TriggerRapidFire[Index]	= GetCheckBox(
												 Wnd
												,IDC_LEFT_TRIGGER_RAPID_FIRE + ( Index * 2 ) );
	}

	//	uڍאݒv
	GetTrackBarRange(
		 Wnd
		,IDC_TRIGGER_DEAD_ZONE
		,&Setting->TriggerMinThreshold
		,&Setting->TriggerMaxThreshold );
	Setting->TriggerButtonThreshold		= GetTrackBarPos( Wnd, IDC_TRIGGER_THRESHOLD );
}
