
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	PageProc6
//----------------------------------------------------------------------------------------------
INT_PTR CALLBACK PageProc6(
	 HWND	Wnd
	,UINT	Message
	,WPARAM	wParam
	,LPARAM	lParam )
{
	//	ϐ錾
	INT_PTR	Result	= FALSE;

	//	bZ[WɂďU蕪
	switch( Message )
	{
		case WM_INITDIALOG:
			Result	= WM_InitDialog6( Wnd );
			break;

		case WM_COMMAND:
			Result	= WM_Command6( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

		case WM_HSCROLL:
			Result	= WM_HScroll6( Wnd, HIWORD( wParam ), LOWORD( wParam ), (HWND)lParam );
			break;

	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_INITDIALOG
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_InitDialog6( HWND Wnd )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	uAN`G[^̐Uv
	InitTrackBar( Wnd, IDC_LEFT_ACTUATOR_LEVEL, 0, 100, 10, 10 );

	//	uEAN`G[^̐Uv
	InitTrackBar( Wnd, IDC_RIGHT_ACTUATOR_LEVEL, 0, 100, 10, 10 );

	//	uU臒lv
	InitTrackBar( Wnd, IDC_ACTUATOR_DEAD_ZONE, 0, 100, 10, 10 );

	//	IĂݒ_CAOɔf
	SetPageSetting6( Wnd, &CurrentSetting );

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_COMMAND
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_Command6(
	 HWND	Wnd
	,WORD	NotifyMessage
	,WORD	ControlID
	,HWND	Control )
{
	//	ϐ錾
	INT_PTR	Result	= 0;

	//	Rg[ɂďU蕪
	switch( ControlID )
	{
		case IDC_FORCE_FEEDBACK:

			//	ʒmbZ[WɂďU蕪
			switch( NotifyMessage )
			{
				case BN_CLICKED:
					if( SendMessage( Control, BM_GETCHECK, 0, 0 ) == 0 )
					{
						EnableControl( Wnd, IDC_STATIC_601, IDC_STATIC_613, FALSE );
					} else {
						EnableControl( Wnd, IDC_STATIC_601, IDC_STATIC_613, TRUE );
					}

					//	vpeB V[gɕύXʒm
					NotifyChange( Wnd );
					break;
			}
			break;

	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	WM_HSCROLL
//----------------------------------------------------------------------------------------------
STDAPI_(INT_PTR) WM_HScroll6(
	 HWND	Wnd
	,WORD	Request
	,WORD	Value
	,HWND	Control )
{
	//	ϐ錾
			INT_PTR	Result	= 0;
	static	BOOL	Selecting;

	//	uAN`G[^̐UvAuAN`G[^̐UṽbZ[W
	if(	( Control == GetDlgItem( Wnd, IDC_LEFT_ACTUATOR_LEVEL ) )
	||	( Control == GetDlgItem( Wnd, IDC_RIGHT_ACTUATOR_LEVEL ) ) )
	{
		//	vpeB V[gɕύXʒm
		NotifyChange( Wnd );
	}

	//	uU̗Ĺ͈ṽbZ[W
	if( Control == GetDlgItem( Wnd, IDC_ACTUATOR_DEAD_ZONE ) )
	{
		if( SelectTrackBar( Control, Request, &Selecting ) == TRUE )
		{
			//	vpeB V[gɕύXʒm
			NotifyChange( Wnd );
		}
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	SetPageSetting6
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetPageSetting6(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	uRg[̐Uv
	SetCheckBox( Wnd, IDC_FORCE_FEEDBACK, Setting->ForceFeedback );
	if( Setting->ForceFeedback == 0 )
	{
		EnableControl( Wnd, IDC_STATIC_601, IDC_STATIC_613, FALSE );
	} else {
		EnableControl( Wnd, IDC_STATIC_601, IDC_STATIC_613, TRUE );
	}

	//	uŰv
	SetTrackBarPos( Wnd, IDC_LEFT_ACTUATOR_LEVEL, Setting->ActuatorLevel[0] );
	SetTrackBarPos( Wnd, IDC_RIGHT_ACTUATOR_LEVEL, Setting->ActuatorLevel[1] );

	//	uڍאݒv
	SetTrackBarRange(
		 Wnd
		,IDC_ACTUATOR_DEAD_ZONE
		,Setting->ActuatorMinThreshold
		,Setting->ActuatorMaxThreshold );
	SetTrackBarPos( Wnd, IDC_ACTUATOR_DEAD_ZONE, Setting->ActuatorMinThreshold );
}

//----------------------------------------------------------------------------------------------
//	GetPageSetting6
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetPageSetting6(
	 HWND		Wnd
	,SETTING *	Setting )
{
	//	uRg[̐Uv
	Setting->ForceFeedback		= GetCheckBox( Wnd, IDC_FORCE_FEEDBACK );

	//	uŰv
	Setting->ActuatorLevel[0]	= GetTrackBarPos( Wnd, IDC_LEFT_ACTUATOR_LEVEL );
	Setting->ActuatorLevel[1]	= GetTrackBarPos( Wnd, IDC_RIGHT_ACTUATOR_LEVEL );

	//	uڍאݒv
	GetTrackBarRange(
		 Wnd
		,IDC_ACTUATOR_DEAD_ZONE
		,&Setting->ActuatorMinThreshold
		,&Setting->ActuatorMaxThreshold );
}
