
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	O[oϐ錾
//----------------------------------------------------------------------------------------------

IDIGameCntrlPropSheetVtbl	PropSheetVtbl	=
{
	 PropSheet_QueryInterface
	,PropSheet_AddRef
	,PropSheet_Release
	,PropSheet_GetSheetInfo
	,PropSheet_GetPageInfo
	,PropSheet_SetID
	,PropSheet_GetID
};

const GUID	IID_IDIGameCntrlPropSheet	=
{
	0x7854FB22, 0x8EE3, 0x11D0, 0xA1, 0xAC, 0x00, 0x00, 0xF8, 0x02, 0x69, 0x77
};

//----------------------------------------------------------------------------------------------
//	PropSheet_New
//----------------------------------------------------------------------------------------------

STDMETHODIMP PropSheet_New(
	 REFIID		InterfaceID
	,LPVOID *	Obj )
{
	//	ϐ錾
	HRESULT			Result	= S_OK;
	PROP_SHEET *	PropSheet;

	//	vpeB[ V[g쐬
	PropSheet	= LocalAlloc( LPTR | LMEM_ZEROINIT, sizeof( PROP_SHEET ) );
	if( PropSheet != NULL )
	{
		//	C^[tFCXݒ肷
		PropSheet->Interface.lpVtbl	= &PropSheetVtbl;

		//	QƃJE^
		PropSheet->ReferenceCount	= 1;
		IncrementReference();

		//	g̃C^[tFCX擾
		Result	= PropSheet_QueryInterface( &PropSheet->Interface, InterfaceID, Obj );
		//	QƃJE^𒲐
		PropSheet_Release( &PropSheet->Interface );
	} else {
		Result	= E_OUTOFMEMORY;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	PropSheet_QueryInterface
//----------------------------------------------------------------------------------------------
STDMETHODIMP PropSheet_QueryInterface(
	 IDIGameCntrlPropSheet *	PropSheetInterface
	,REFIID						InterfaceID
	,LPVOID *					Obj )
{
	//	ϐ錾
	HRESULT	Result	= S_OK;

	//	g̃C^[tFCXԂ
	if(	IsEqualIID( InterfaceID, &IID_IUnknown )
	||	IsEqualIID( InterfaceID, &IID_IDIGameCntrlPropSheet ) )
	{
		PropSheet_AddRef( PropSheetInterface );
		*Obj	= PropSheetInterface;
	} else {
		*Obj	= NULL;
		Result	= E_NOINTERFACE;
	}

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	PropSheet_AddRef
//----------------------------------------------------------------------------------------------
STDMETHODIMP_(ULONG) PropSheet_AddRef( IDIGameCntrlPropSheet * PropSheetInterface )
{
	//	ϐ錾
	PROP_SHEET *	PropSheet	= (PPROP_SHEET)PropSheetInterface;

	//	QƃJE^Z
	return( InterlockedIncrement( (LPLONG)&PropSheet->ReferenceCount ) );
}

//----------------------------------------------------------------------------------------------
//	PropSheet_Release
//----------------------------------------------------------------------------------------------
STDMETHODIMP_(ULONG) PropSheet_Release( IDIGameCntrlPropSheet * PropSheetInterface )
{
	//	ϐ錾
	PROP_SHEET *	PropSheet	= (PPROP_SHEET)PropSheetInterface;

	//	QƃJE^Z
	return( InterlockedDecrement( (LPLONG)&PropSheet->ReferenceCount ) );
}

//----------------------------------------------------------------------------------------------
//	PropSheet_GetSheetInfo
//----------------------------------------------------------------------------------------------
STDMETHODIMP PropSheet_GetSheetInfo(
	 IDIGameCntrlPropSheet *	PropSheetInterface
	,LPDIGCSHEETINFO *			SheetInfo )
{
	//	ϐ錾
	HRESULT			Result			= S_OK;
	PROP_SHEET *	PropSheet		= (PPROP_SHEET)PropSheetInterface;
	WCHAR *			SheetCaption	= (WCHAR *)LocalAlloc( LPTR, sizeof( WCHAR ) * MAX_PATH );
	_TCHAR			SheetCaptionRes[MAX_PATH];

	//	\[XV[g擾
	LoadString( Instance, IDS_SHEET_CAPTION, SheetCaptionRes, sizeof( TCHAR ) * MAX_PATH );

#ifdef	UNICODE
	_tcscpy( SheetCaption, SheetCaptionRes );
#else
	MultiByteToWideChar(
		 CP_ACP
		,0
		,SheetCaptionRes
		,-1
		,SheetCaption
		,sizeof( WCHAR ) * MAX_PATH );
#endif

	//	vpeB V[g̏ݒ肷
	PropSheet->SheetInfo.dwSize				= sizeof( DIGCSHEETINFO );
	PropSheet->SheetInfo.nNumPages			= sizeof( PropSheet->PageInfo )
												/ sizeof( DIGCPAGEINFO );
	PropSheet->SheetInfo.lpwszSheetCaption	= SheetCaption;
	PropSheet->SheetInfo.fSheetIconFlag		= TRUE;
	PropSheet->SheetInfo.lpwszSheetIcon		= MAKEINTRESOURCEW( IDI_ICON );
	*SheetInfo	= &PropSheet->SheetInfo;

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	PropSheet_GetPageInfo
//----------------------------------------------------------------------------------------------
STDMETHODIMP PropSheet_GetPageInfo(
	 IDIGameCntrlPropSheet *	PropSheetInterface
	,LPDIGCPAGEINFO *			PageInfo )
{
	//	ϐ錾
	HRESULT			Result		= S_OK;
	PROP_SHEET *	PropSheet	= (PPROP_SHEET)PropSheetInterface;

	//	vpeB V[g̃y[Wݒ肷
	PropSheet->PageInfo[0].dwSize			= sizeof( DIGCPAGEINFO );
	PropSheet->PageInfo[0].lpwszPageTitle	= NULL;
	PropSheet->PageInfo[0].fpPageProc		= PageProc1;
	PropSheet->PageInfo[0].fProcFlag		= FALSE;
	PropSheet->PageInfo[0].fpPrePostProc	= NULL;
	PropSheet->PageInfo[0].fIconFlag		= FALSE;
	PropSheet->PageInfo[0].lpwszPageIcon	= NULL;
	PropSheet->PageInfo[0].lpwszTemplate	= MAKEINTRESOURCEW( IDD_CONTROLLER );
	PropSheet->PageInfo[0].lParam			= 0;
	PropSheet->PageInfo[0].hInstance		= Instance;

	PropSheet->PageInfo[1].dwSize			= sizeof( DIGCPAGEINFO );
	PropSheet->PageInfo[1].lpwszPageTitle	= NULL;
	PropSheet->PageInfo[1].fpPageProc		= PageProc2;
	PropSheet->PageInfo[1].fProcFlag		= FALSE;
	PropSheet->PageInfo[1].fpPrePostProc	= NULL;
	PropSheet->PageInfo[1].fIconFlag		= FALSE;
	PropSheet->PageInfo[1].lpwszPageIcon	= NULL;
	PropSheet->PageInfo[1].lpwszTemplate	= MAKEINTRESOURCEW( IDD_STICK );
	PropSheet->PageInfo[1].lParam			= 0;
	PropSheet->PageInfo[1].hInstance		= Instance;

	PropSheet->PageInfo[2].dwSize			= sizeof( DIGCPAGEINFO );
	PropSheet->PageInfo[2].lpwszPageTitle	= NULL;
	PropSheet->PageInfo[2].fpPageProc		= PageProc3;
	PropSheet->PageInfo[2].fProcFlag		= FALSE;
	PropSheet->PageInfo[2].fpPrePostProc	= NULL;
	PropSheet->PageInfo[2].fIconFlag		= FALSE;
	PropSheet->PageInfo[2].lpwszPageIcon	= NULL;
	PropSheet->PageInfo[2].lpwszTemplate	= MAKEINTRESOURCEW( IDD_DIRECTIONAL_PAD );
	PropSheet->PageInfo[2].lParam			= 0;
	PropSheet->PageInfo[2].hInstance		= Instance;

	PropSheet->PageInfo[3].dwSize			= sizeof( DIGCPAGEINFO );
	PropSheet->PageInfo[3].lpwszPageTitle	= NULL;
	PropSheet->PageInfo[3].fpPageProc		= PageProc4;
	PropSheet->PageInfo[3].fProcFlag		= FALSE;
	PropSheet->PageInfo[3].fpPrePostProc	= NULL;
	PropSheet->PageInfo[3].fIconFlag		= FALSE;
	PropSheet->PageInfo[3].lpwszPageIcon	= NULL;
	PropSheet->PageInfo[3].lpwszTemplate	= MAKEINTRESOURCEW( IDD_TRIGGER );
	PropSheet->PageInfo[3].lParam			= 0;
	PropSheet->PageInfo[3].hInstance		= Instance;

	PropSheet->PageInfo[4].dwSize			= sizeof( DIGCPAGEINFO );
	PropSheet->PageInfo[4].lpwszPageTitle	= NULL;
	PropSheet->PageInfo[4].fpPageProc		= PageProc5;
	PropSheet->PageInfo[4].fProcFlag		= FALSE;
	PropSheet->PageInfo[4].fpPrePostProc	= NULL;
	PropSheet->PageInfo[4].fIconFlag		= FALSE;
	PropSheet->PageInfo[4].lpwszPageIcon	= NULL;
	PropSheet->PageInfo[4].lpwszTemplate	= MAKEINTRESOURCEW( IDD_BUTTON );
	PropSheet->PageInfo[4].lParam			= 0;
	PropSheet->PageInfo[4].hInstance		= Instance;

	PropSheet->PageInfo[5].dwSize			= sizeof( DIGCPAGEINFO );
	PropSheet->PageInfo[5].lpwszPageTitle	= NULL;
	PropSheet->PageInfo[5].fpPageProc		= PageProc6;
	PropSheet->PageInfo[5].fProcFlag		= FALSE;
	PropSheet->PageInfo[5].fpPrePostProc	= NULL;
	PropSheet->PageInfo[5].fIconFlag		= FALSE;
	PropSheet->PageInfo[5].lpwszPageIcon	= NULL;
	PropSheet->PageInfo[5].lpwszTemplate	= MAKEINTRESOURCEW( IDD_FORCE_FEEDBACK );
	PropSheet->PageInfo[5].lParam			= 0;
	PropSheet->PageInfo[5].hInstance		= Instance;

	PropSheet->PageInfo[6].dwSize			= sizeof( DIGCPAGEINFO );
	PropSheet->PageInfo[6].lpwszPageTitle	= NULL;
	PropSheet->PageInfo[6].fpPageProc		= PageProc7;
	PropSheet->PageInfo[6].fProcFlag		= FALSE;
	PropSheet->PageInfo[6].fpPrePostProc	= NULL;
	PropSheet->PageInfo[6].fIconFlag		= FALSE;
	PropSheet->PageInfo[6].lpwszPageIcon	= NULL;
	PropSheet->PageInfo[6].lpwszTemplate	= MAKEINTRESOURCEW( IDD_DETAIL );
	PropSheet->PageInfo[6].lParam			= 0;
	PropSheet->PageInfo[6].hInstance		= Instance;

	*PageInfo	= PropSheet->PageInfo;

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	PropSheet_SetID
//----------------------------------------------------------------------------------------------
STDMETHODIMP PropSheet_SetID(
	 IDIGameCntrlPropSheet *	PropSheetInterface
	,USHORT						Id )
{
	//	ϐ錾
	HRESULT			Result		= S_OK;
	PROP_SHEET *	PropSheet	= (PPROP_SHEET)PropSheetInterface;

	//	ID ݒ肷
	PropSheet->Id	= Id;

	return( Result );
}

//----------------------------------------------------------------------------------------------
//	PropSheet_GetID
//----------------------------------------------------------------------------------------------
STDMETHODIMP_(USHORT) PropSheet_GetID( IDIGameCntrlPropSheet * PropSheetInterface )
{
	//	ϐ錾
	PROP_SHEET *	PropSheet	= (PPROP_SHEET)PropSheetInterface;

	//	ID Ԃ
	return( PropSheet->Id );
}
