
//	Control Panel for Microsoft Xbox 360 Controller

#include	"X360CCP.h"

//----------------------------------------------------------------------------------------------
//	GetDefaultSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetDefaultSetting( SETTING * Setting )
{
	//	ϐ錾
	LONG	Index;

	//	ftHg̐ݒs
	RtlZeroMemory( Setting, sizeof( SETTING ) );

	//	XeBbN
	for( Index = 0; Index < 2; Index ++ )
	{
		Setting->StickUsage[Index]					= Index;
		Setting->StickReverse[Index]				= 0;
	}
	Setting->StickMinThreshold					= 15;
	Setting->StickMaxThreshold					= 95;
	Setting->StickHatSwitchThreshold			= 50;

	//	pbh
	Setting->DirectionalPadUsage				= 14;
	Setting->DirectionalPadReverse				= 0;
	for( Index = 0; Index < 4; Index ++ )
	{
		Setting->DirectionalPadWayUsage[Index]		= 20 + Index;
		Setting->DirectionalPadWayRapidFire[Index]	= 0;
	}

	//	gK[
	Setting->TriggerUsage[0]					= 18;
	Setting->TriggerRapidFire[0]				= 0;
	Setting->TriggerUsage[1]					= 19;
	Setting->TriggerRapidFire[1]				= 0;
	Setting->TriggerMinThreshold				= 15;
	Setting->TriggerMaxThreshold				= 95;
	Setting->TriggerButtonThreshold				= 85;

	//	{^
	for( Index = 0; Index < 10; Index ++ )
	{
		Setting->ButtonUsage[Index]					= 8 + Index;
		Setting->ButtonRapidFire[Index]				= 0;
		Setting->ButtonRapidFireSpeed[Index]		= 100;
	}
	Setting->ButtonUsage[10]					= 20;
	Setting->ButtonRapidFire[10]				= 0;
	Setting->ButtonRapidFireSpeed[10]			= 100;

	//	O Cg
	Setting->RingLightPattern					= 0;

	//	U
	Setting->ForceFeedback						= 1;
	Setting->ActuatorLevel[0]					= 80;
	Setting->ActuatorLevel[1]					= 80;
	Setting->ActuatorMinThreshold				= 20;
	Setting->ActuatorMaxThreshold				= 100;

	//	ڍאݒ
	Setting->StickDeadZoneType					= 0;
	for( Index = 0; Index < 2; Index ++ )
	{
		Setting->SlideSliderValue[Index]			= 1;
#ifndef UNICODE
		Setting->SlideCenterValue[Index]			= 1;
#else
		Setting->SlideCenterValue[Index]			= 0;
#endif
		Setting->ReverseSliderValue[Index]			= 0;
	}
	for( Index = 2; Index < 4; Index ++ )
	{
		Setting->SlideSliderValue[Index]			= 0;
#ifndef UNICODE
		Setting->SlideCenterValue[Index]			= 1;
#else
		Setting->SlideCenterValue[Index]			= 0;
#endif
		Setting->ReverseSliderValue[Index]			= 0;
	}
	Setting->LimitationMode						= 0;
	Setting->DevicesArePolled					= 1;
	Setting->ReduceOutputReport					= 0;
}

//----------------------------------------------------------------------------------------------
//	SetCurrentSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetCurrentSetting( SETTING * Setting )
{
	//	݂̃Rg[̐ݒݒ肷
	SetRegistry( Setting, REG_BINARY, sizeof( SETTING ), CURRENT_SETTING );
}

//----------------------------------------------------------------------------------------------
//	GetCurrentSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetCurrentSetting( SETTING * Setting )
{
	//	݂̃Rg[̐ݒ擾
	GetRegistry( Setting, REG_BINARY, sizeof( SETTING ), CURRENT_SETTING );
}

//----------------------------------------------------------------------------------------------
//	SetCurrentSettingIndex
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetCurrentSettingIndex( LONG SettingIndex )
{
	//	Rg[̐ݒ̏Ԃݒ肷
	SetRegistry( &SettingIndex, REG_DWORD, sizeof( SettingIndex ), CURRENT_SETTING_INDEX );
}

//----------------------------------------------------------------------------------------------
//	GetCurrentSettingIndex
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) GetCurrentSettingIndex()
{
	//	ϐ錾
	DWORD	SettingIndex	= 0;

	//	Rg[̐ݒ̏Ԃ擾
	GetRegistry( &SettingIndex, REG_DWORD, sizeof( SettingIndex ), CURRENT_SETTING_INDEX );

	return( SettingIndex );
}

//----------------------------------------------------------------------------------------------
//	SetSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetSetting(
	 SETTING *	Setting
	,LONG		SettingIndex )
{
	//	ϐ錾
	_TCHAR	ValueName[MAX_PATH];

	//	Rg[̐ݒݒ肷
	_stprintf( ValueName, SETTING_DATA, SettingIndex );
	SetRegistry( Setting, REG_BINARY, sizeof( SETTING ), ValueName );
}

//----------------------------------------------------------------------------------------------
//	GetSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetSetting(
	 SETTING *	Setting
	,LONG		SettingIndex )
{
	//	ϐ錾
	_TCHAR	ValueName[MAX_PATH];

	//	Rg[̐ݒ擾
	if( SettingIndex == 0 )
	{
		GetDefaultSetting( Setting );
	} else {
		_stprintf( ValueName, SETTING_DATA, SettingIndex );
		GetRegistry( Setting, REG_BINARY, sizeof( SETTING ), ValueName );
	}
}

//----------------------------------------------------------------------------------------------
//	DelSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) DelSetting( LONG SettingIndex )
{
	//	ϐ錾
	_TCHAR	ValueName[MAX_PATH];

	//	Rg[̐ݒ폜
	_stprintf( ValueName, SETTING_DATA, SettingIndex );
	DelRegistry( ValueName );
}

//----------------------------------------------------------------------------------------------
//	SetSettingName
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetSettingName(
	 _TCHAR *	SettingName
	,LONG		SettingIndex )
{
	//	ϐ錾
	_TCHAR	ValueName[MAX_PATH];

	//	Rg[̐ݒ̖̂ݒ肷
	_stprintf( ValueName, SETTING_NAME, SettingIndex );
	SetRegistry(
		 SettingName
		,REG_SZ
		,( _tcslen( SettingName ) + 1 ) * sizeof( _TCHAR )
		,ValueName );
}

//----------------------------------------------------------------------------------------------
//	GetSettingName
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetSettingName(
	 _TCHAR *	SettingName
	,LONG		SettingNameSize
	,LONG		SettingIndex )
{
	//	ϐ錾
	_TCHAR	ValueName[MAX_PATH];

	//	Rg[̐ݒ̖̂擾
	_stprintf( ValueName, SETTING_NAME, SettingIndex );
	GetRegistry( SettingName, REG_SZ, SettingNameSize, ValueName );
}

//----------------------------------------------------------------------------------------------
//	DelSettingName
//----------------------------------------------------------------------------------------------
STDAPI_(void) DelSettingName( LONG SettingIndex )
{
	//	ϐ錾
	_TCHAR	ValueName[MAX_PATH];

	//	Rg[̐ݒ̖̂폜
	_stprintf( ValueName, SETTING_NAME, SettingIndex );
	DelRegistry( ValueName );
}

//----------------------------------------------------------------------------------------------
//	SetSettingCount
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetSettingCount( LONG SettingCount )
{
	//	Rg[̐ݒ̐ݒ肷
	SetRegistry( &SettingCount, REG_DWORD, sizeof( SettingCount ), SETTING_COUNT );
}

//----------------------------------------------------------------------------------------------
//	GetSettingCount
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) GetSettingCount()
{
	//	ϐ錾
	DWORD	SettingCount	= 1;

	//	Rg[̐ݒ̐擾
	GetRegistry( &SettingCount, REG_DWORD, sizeof( SettingCount ), SETTING_COUNT );

	return( SettingCount );
}

//----------------------------------------------------------------------------------------------
//	SetModifiedFlag
//----------------------------------------------------------------------------------------------
STDAPI_(void) SetModifiedFlag( BOOL ModifiedFlag )
{
	//	ύXς݃tOݒ肷
	SetRegistry( &ModifiedFlag, REG_DWORD, sizeof( ModifiedFlag ), MODIFIED_FLAG );
}

//----------------------------------------------------------------------------------------------
//	GetModifiedFlag
//----------------------------------------------------------------------------------------------
STDAPI_(BOOL) GetModifiedFlag()
{
	//	ϐ錾
	BOOL	ModifiedFlag	= FALSE;

	//	ύXς݃tO擾
	GetRegistry( &ModifiedFlag, REG_DWORD, sizeof( ModifiedFlag ), MODIFIED_FLAG );

	return( ModifiedFlag );
}

