
//	Control Panel for Microsoft Xbox 360 Controller

#define	UNICODE
#define	_UNICODE

#include	<windows.h>
#include	<tchar.h>
#include	<stdio.h>
#include	<objbase.h>
#include	<setupapi.h>
#include	<hidsdi.h>

#include	"Resource.h"

//----------------------------------------------------------------------------------------------
//	\̐錾iVXej
//----------------------------------------------------------------------------------------------

typedef struct
{
	DWORD		dwSize;				//	Should be set to sizeof( DIGCPAGEINFO )
	LPWSTR		lpwszPageTitle;		//	Text to be displayed on tab
	DLGPROC		fpPageProc;			//	Dialog Procedure for page
	BOOL		fProcFlag;			//	TRUE if you are using fpPrePostProc member
	DLGPROC		fpPrePostProc;		//	Pointer to Callback function that is Only called on Init!
	BOOL		fIconFlag;			//	TRUE if you are using lpwszPageIcon member
	LPWSTR		lpwszPageIcon;		//	Resource ID or name of icon
	LPWSTR		lpwszTemplate;		//	Dialog template
	LPARAM		lParam;				//	Application defined data
	HINSTANCE	hInstance;			//	Handle of Instance to load Icon/Cursor
} DIGCPAGEINFO, *LPDIGCPAGEINFO;

typedef struct
{
	DWORD		dwSize;				//	Should but set to sizeof( DIGCSHEETINFO )
	USHORT		nNumPages;			//	Number of pages on this sheet
	LPWSTR		lpwszSheetCaption;	//	Text to be used in Sheet Window Title
	BOOL		fSheetIconFlag;		//	TRUE if you are using the lpwszSheetIcon member
	LPWSTR		lpwszSheetIcon;		//	Resource ID or name of icon
} DIGCSHEETINFO, *LPDIGCSHEETINFO;

//----------------------------------------------------------------------------------------------
//	C^[tFCX錾iVXej
//----------------------------------------------------------------------------------------------

#undef INTERFACE
#define INTERFACE IDIGameCntrlPropSheet
DECLARE_INTERFACE_( IDIGameCntrlPropSheet, IUnknown )
{
	// IUnknown Members
	STDMETHOD( QueryInterface )		( THIS_ REFIID, LPVOID * ) PURE;
	STDMETHOD_( ULONG, AddRef )		( THIS ) PURE;
	STDMETHOD_( ULONG, Release )	( THIS ) PURE;

	// IServerProperty Members
	STDMETHOD( GetSheetInfo )		( THIS_ LPDIGCSHEETINFO * ) PURE;
	STDMETHOD( GetPageInfo )		( THIS_ LPDIGCPAGEINFO * ) PURE;
	STDMETHOD( SetID )				( THIS_ USHORT ) PURE;
	STDMETHOD_( USHORT, GetID )		( THIS ) PURE;
};

//----------------------------------------------------------------------------------------------
//	萔錾
//----------------------------------------------------------------------------------------------

#define	CONTROLLER					0
#define	STICK						1
#define	DIRECTIONAL_PAD				2
#define	TRIGGER						3
#define	BUTTON						4
#define	FORCE_FEEDBACK				5
#define	DETAIL						6
#define	PAGE_COUNT					7

#define	CENTER						0
#define	CENTER_PLUS					1
#define	STRAIGHT					2
#define	RING_LIGHT					3
#define	LIMITATION_MODE				4

#define	NOTHING_POS_CENTER			18
#define	NOTHING_POS_CENTER_PLUS		18
#define	NOTHING_POS_STRAIGHT		40

#define	WAY_POS_CENTER_PLUS			18

#define	BUTTON_LIST					0
#define	SLIDER_LIST					1

#define	POLLING_TIMER_ID			1
#define POLLING_INTERVAL			16

#define	APPLY_DEVICE				0
#define	IN_REPORT					1
#define	OUT_REPORT					2

#define	DIRECTIONAL_PAD_UP			0x0001
#define	DIRECTIONAL_PAD_DOWN		0x0002
#define	DIRECTIONAL_PAD_LEFT		0x0004
#define	DIRECTIONAL_PAD_RIGHT		0x0008
#define	START_BUTTON				0x0010
#define	BACK_BUTTON					0x0020
#define	LEFT_STICK_BUTTON			0x0040
#define	RIGHT_STICK_BUTTON			0x0080
#define	LB_BUTTON					0x0100
#define	RB_BUTTON					0x0200
#define	XBOX_GUIDE_BUTTON			0x0400
#define	A_BUTTON					0x1000
#define	B_BUTTON					0x2000
#define	X_BUTTON					0x4000
#define	Y_BUTTON					0x8000

#define	X360CCP_MUTEX_NAME			_T( "X360CCP" )

#define	REGISTRY_SUB_KEY			_T( "SYSTEM\\CurrentControlSet\\Services\\Xbox360Controller\\Parameters" )

#define	CURRENT_SETTING				_T( "Current Setting" )
#define	CURRENT_SETTING_INDEX		_T( "Current Setting Index" )
#define	SETTING_DATA				_T( "Setting %d" )
#define	SETTING_NAME				_T( "Setting Name %d" )
#define	SETTING_COUNT				_T( "Setting Count" )
#define	MODIFIED_FLAG				_T( "Modified Flag" )

#define	SUPPORT_DEVICE_COUNT		_T( "Support Device Count" )
#define	SUPPORT_DEVICE_ATTRIBUTE	_T( "Support Device Attribute %d" )

//----------------------------------------------------------------------------------------------
//	\̐錾
//----------------------------------------------------------------------------------------------

typedef struct _PROP_SHEET
{
	IDIGameCntrlPropSheet	Interface;
	LONG					ReferenceCount;
	DIGCSHEETINFO			SheetInfo;
	DIGCPAGEINFO			PageInfo[PAGE_COUNT];
	USHORT					Id;
} PROP_SHEET, *PPROP_SHEET;

typedef struct _SETTING
{
	ULONG	StickUsage[2];
	ULONG	StickReverse[2];
	ULONG	StickMinThreshold;
	ULONG	StickMaxThreshold;
	ULONG	StickHatSwitchThreshold;
	ULONG	DirectionalPadUsage;
	ULONG	DirectionalPadReverse;
	ULONG	DirectionalPadWayUsage[4];
	ULONG	DirectionalPadWayRapidFire[4];
	ULONG	TriggerUsage[2];
	ULONG	TriggerRapidFire[2];
	ULONG	TriggerMinThreshold;
	ULONG	TriggerMaxThreshold;
	ULONG	TriggerButtonThreshold;
	ULONG	ButtonUsage[11];
	ULONG	ButtonRapidFire[11];
	ULONG	ButtonRapidFireSpeed[11];
	ULONG	RingLightPattern;
	ULONG	ForceFeedback;
	ULONG	ActuatorLevel[2];
	ULONG	ActuatorMinThreshold;
	ULONG	ActuatorMaxThreshold;
	ULONG	StickDeadZoneType;
	ULONG	SlideSliderValue[4];
	ULONG	SlideCenterValue[4];
	ULONG	ReverseSliderValue[4];
	ULONG	LimitationMode;
	ULONG	DevicesArePolled;
	ULONG	ReduceOutputReport;
} SETTING, *PSETTING;

typedef struct _INPUT_REPORT
{
	UCHAR	Zero1;
	UCHAR	Length;
	USHORT	DigitalButton;
	UCHAR	LeftTrigger;
	UCHAR	RightTrigger;
	SHORT	LeftStickX;
	SHORT	LeftStickY;
	SHORT	RightStickX;
	SHORT	RightStickY;
	UCHAR	Dummy1;
	UCHAR	Dummy2;
	UCHAR	Dummy3;
	UCHAR	Dummy4;
	UCHAR	Dummy5;
	UCHAR	Dummy6;
} INPUT_REPORT, *PINPUT_REPORT;

typedef struct _REPORT
{
#ifndef UNICODE
	USHORT	XAxis;
	USHORT	YAxis;
	USHORT	XRotation;
	USHORT	YRotation;
#else
	SHORT	XAxis;
	SHORT	YAxis;
	SHORT	XRotation;
	SHORT	YRotation;
#endif
	UCHAR	ZAxis;
	UCHAR	ZRotation;
	UCHAR	Slider2;
	UCHAR	Slider1;
	CHAR	HatSwitch1;
	CHAR	HatSwitch2;
	CHAR	HatSwitch3;
	CHAR	HatSwitch4;
	ULONG	Button;
} REPORT, *PREPORT;

//----------------------------------------------------------------------------------------------
//	O[oϐ錾
//----------------------------------------------------------------------------------------------

//	X360CCP.c
extern	HINSTANCE			Instance;

//	Common.c
extern	LONG				ReferenceCount;
extern	CRITICAL_SECTION	CriticalSection;

//	PageProc1.c
extern	SETTING				CurrentSetting;
extern	LONG				CurrentSettingIndex;
extern	BOOL				ModifiedFlag;
extern	ULONG				SupportDeviceCount;
extern	ULONG *				SupportDeviceAttribute;

//----------------------------------------------------------------------------------------------
//	֐錾
//----------------------------------------------------------------------------------------------

//	X360CCP.c
STDAPI_(BOOL) DllMain( HINSTANCE, DWORD, LPVOID );
STDAPI_(void) ProcessAttach( HINSTANCE );
STDAPI_(void) ProcessDetach();

//	Common.c
STDAPI_(LONG) IncrementReference();
STDAPI_(LONG) DecrementReference();
STDAPI_(void) EnterCritical();
STDAPI_(void) LeaveCritical();

//	COM.c
STDAPI DllGetClassObject( REFCLSID, REFIID, LPVOID * );
STDAPI DllCanUnloadNow();

//	ClassFactory.c
STDMETHODIMP ClassFactory_New( REFIID, LPVOID * );
STDMETHODIMP ClassFactory_QueryInterface( IClassFactory *, REFIID, LPVOID * );
STDMETHODIMP_(ULONG) ClassFactory_AddRef( IClassFactory * );
STDMETHODIMP_(ULONG) ClassFactory_Release( IClassFactory * );
STDMETHODIMP ClassFactory_CreateInstance( IClassFactory *, IUnknown *, REFIID, LPVOID * );
STDMETHODIMP ClassFactory_LockServer( IClassFactory *, BOOL );

//	PropSheet.c
STDMETHODIMP PropSheet_New( REFIID, LPVOID * );
STDMETHODIMP PropSheet_QueryInterface( IDIGameCntrlPropSheet *, REFIID, LPVOID * );
STDMETHODIMP_(ULONG) PropSheet_AddRef( IDIGameCntrlPropSheet * );
STDMETHODIMP_(ULONG) PropSheet_Release( IDIGameCntrlPropSheet * );
STDMETHODIMP PropSheet_GetSheetInfo( IDIGameCntrlPropSheet *, LPDIGCSHEETINFO * );
STDMETHODIMP PropSheet_GetPageInfo( IDIGameCntrlPropSheet *, LPDIGCPAGEINFO * );
STDMETHODIMP PropSheet_SetID( IDIGameCntrlPropSheet *, USHORT );
STDMETHODIMP_(USHORT) PropSheet_GetID( IDIGameCntrlPropSheet * );

//	PageProc1.c
INT_PTR CALLBACK PageProc1( HWND, UINT, WPARAM, LPARAM );
STDAPI_(INT_PTR) WM_InitDialog1( HWND );
STDAPI_(INT_PTR) WM_Command1( HWND, WORD, WORD, HWND );
STDAPI_(INT_PTR) WM_Notify1( HWND, LONG, NMHDR * );
STDAPI_(INT_PTR) WM_Timer1( HWND );
STDAPI_(void) InitSettingList( HWND, ULONG );
STDAPI_(void) SelectSettingList( HWND, HWND );
STDAPI_(void) DeleteSettingList( HWND );
STDAPI_(void) ChangeCurrentSetting( HWND );

//	PageProc2.c
INT_PTR CALLBACK PageProc2( HWND, UINT, WPARAM, LPARAM );
STDAPI_(INT_PTR) WM_InitDialog2( HWND );
STDAPI_(INT_PTR) WM_Command2( HWND, WORD, WORD, HWND );
STDAPI_(INT_PTR) WM_HScroll2( HWND, WORD, WORD, HWND );
STDAPI_(void) SetPageSetting2( HWND, SETTING * );
STDAPI_(void) GetPageSetting2( HWND, SETTING * );

//	PageProc3.c
INT_PTR CALLBACK PageProc3( HWND, UINT, WPARAM, LPARAM );
STDAPI_(INT_PTR) WM_InitDialog3( HWND );
STDAPI_(INT_PTR) WM_Command3( HWND, WORD, WORD, HWND );
STDAPI_(void) SetPageSetting3( HWND, SETTING * );
STDAPI_(void) GetPageSetting3( HWND, SETTING * );

//	PageProc4.c
INT_PTR CALLBACK PageProc4( HWND, UINT, WPARAM, LPARAM );
STDAPI_(INT_PTR) WM_InitDialog4( HWND );
STDAPI_(INT_PTR) WM_Command4( HWND, WORD, WORD, HWND );
STDAPI_(INT_PTR) WM_HScroll4( HWND, WORD, WORD, HWND );
STDAPI_(void) SetPageSetting4( HWND, SETTING * );
STDAPI_(void) GetPageSetting4( HWND, SETTING * );

//	PageProc5.c
INT_PTR CALLBACK PageProc5( HWND, UINT, WPARAM, LPARAM );
STDAPI_(INT_PTR) WM_InitDialog5( HWND );
STDAPI_(INT_PTR) WM_Command5( HWND, WORD, WORD, HWND );
STDAPI_(INT_PTR) WM_HScroll5( HWND, WORD, WORD, HWND );
STDAPI_(void) SetPageSetting5( HWND, SETTING * );
STDAPI_(void) GetPageSetting5( HWND, SETTING * );
STDAPI_(void) ChangeButtonFunction( HWND, BOOL );

//	PageProc6.c
INT_PTR CALLBACK PageProc6( HWND, UINT, WPARAM, LPARAM );
STDAPI_(INT_PTR) WM_InitDialog6( HWND );
STDAPI_(INT_PTR) WM_Command6( HWND, WORD, WORD, HWND );
STDAPI_(INT_PTR) WM_HScroll6( HWND, WORD, WORD, HWND );
STDAPI_(void) SetPageSetting6( HWND, SETTING * );
STDAPI_(void) GetPageSetting6( HWND, SETTING * );

//	PageProc7.c
INT_PTR CALLBACK PageProc7( HWND, UINT, WPARAM, LPARAM );
STDAPI_(INT_PTR) WM_InitDialog7( HWND );
STDAPI_(INT_PTR) WM_Command7( HWND, WORD, WORD, HWND );
STDAPI_(void) SetPageSetting7( HWND, SETTING * );
STDAPI_(void) GetPageSetting7( HWND, SETTING * );
STDAPI_(void) ChangeSliderFunction( HWND, BOOL );

//	DialogProc.c
LRESULT CALLBACK DialogProc( HWND, UINT, WPARAM, LPARAM );
STDAPI_(INT_PTR) WM_InitDialog8( HWND );
STDAPI_(INT_PTR) WM_Command8( HWND, WORD, WORD, HWND );
STDAPI_(BOOL) ClickOK( HWND Wnd );
STDAPI_(void) SaveNewSetting( HWND );
STDAPI_(void) ReplaceSetting( HWND, LONG );

//	ProcCommon.c
STDAPI_(void) NotifyChange( HWND );
STDAPI_(void) SetDialogSetting( HWND, SETTING * );
STDAPI_(void) GetDialogSetting( HWND, SETTING * );
STDAPI_(void) InitComboBox( HWND, ULONG, LONG );
STDAPI_(void) SelectComboBox( HWND, HWND, ULONG, LONG );
STDAPI_(void) SetComboBox( HWND, ULONG, LONG, ULONG, LONG );
STDAPI_(LONG) GetComboBox( HWND, ULONG );
STDAPI_(void) InitTrackBar( HWND, ULONG, LONG, LONG, LONG, LONG );
STDAPI_(BOOL) SelectTrackBar( HWND, WORD, BOOL * );
STDAPI_(void) SetTrackBarPos( HWND, ULONG, LONG );
STDAPI_(LONG) GetTrackBarPos( HWND, ULONG);
STDAPI_(void) SetTrackBarRange( HWND, ULONG, LONG, LONG );
STDAPI_(void) GetTrackBarRange( HWND, ULONG, LONG *, LONG * );
STDAPI_(void) SetCheckBox( HWND, ULONG, LONG );
STDAPI_(LONG) GetCheckBox( HWND, ULONG );
STDAPI_(void) InitListBox( HWND, ULONG, LONG );
STDAPI_(void) SetListBox( HWND, ULONG, LONG );
STDAPI_(void) SetListBoxItemData( HWND, ULONG, LONG, LONG, LONG, LONG );
STDAPI_(void) GetListBoxItemData( HWND, ULONG, LONG, ULONG *, ULONG *, ULONG * );
STDAPI_(void) UpdateWindowText( HWND, ULONG, LONG );
STDAPI_(void) UpdateWindowTextPlus( HWND, ULONG, ULONG );
STDAPI_(LONG) ShowMessageBox( HWND, ULONG, ULONG, ULONG );
STDAPI_(LONG) ShowMessageBoxPlus( HWND, ULONG, ULONG, _TCHAR *, ULONG );
STDAPI_(void) EnableControl( HWND, ULONG, ULONG, BOOL );

//	Setting.c
STDAPI_(void) GetDefaultSetting( SETTING * );
STDAPI_(void) SetCurrentSetting( SETTING * );
STDAPI_(void) GetCurrentSetting( SETTING * );
STDAPI_(void) SetCurrentSettingIndex( LONG );
STDAPI_(LONG) GetCurrentSettingIndex();
STDAPI_(void) SetSetting( SETTING *, LONG );
STDAPI_(void) GetSetting( SETTING *, LONG );
STDAPI_(void) DelSetting( LONG );
STDAPI_(void) SetSettingName( _TCHAR *, LONG );
STDAPI_(void) GetSettingName( _TCHAR *, LONG, LONG );
STDAPI_(void) DelSettingName( LONG );
STDAPI_(void) SetSettingCount( LONG );
STDAPI_(LONG) GetSettingCount();
STDAPI_(void) SetModifiedFlag( BOOL );
STDAPI_(BOOL) GetModifiedFlag();

//	Registry.c
STDAPI_(void) SetRegistry( VOID *, ULONG, ULONG, _TCHAR * );
STDAPI_(void) GetRegistry( VOID *, ULONG, ULONG, _TCHAR * );
STDAPI_(void) DelRegistry( _TCHAR * );

//	Device.c
STDAPI_(LONG) GetSupportDeviceCount();
STDAPI_(void) GetSupportDeviceList( ULONG * *, LONG );
STDAPI_(void) IoDevice( LONG, INPUT_REPORT *, UCHAR, UCHAR );

//	GenerateReport.c
STDAPI_(void) X360C_GenerateInputReport( INPUT_REPORT *, SETTING *, REPORT * );
STDAPI_(void) X360C_AdjustStick_Axis( LONG, SHORT *, SHORT *, LONG, LONG );
STDAPI_(void) X360C_AdjustStick_HatSwitch( UCHAR *, SHORT, SHORT, LONG );
STDAPI_(void) X360C_AdjustSlider_Slider( UCHAR *, LONG, LONG );
STDAPI_(void) X360C_AdjustSlider_Button( ULONG *, UCHAR, LONG );
STDAPI_(void) X360C_SetAxisRotation( SHORT *, SHORT, SHORT, ULONG, ULONG );
STDAPI_(void) X360C_SetHatSwitch( UCHAR *, UCHAR, ULONG, ULONG );
STDAPI_(void) X360C_SetSlider( SHORT *, SHORT, ULONG, ULONG, ULONG, ULONG *, ULONG * );
STDAPI_(void) X360C_SetButton( ULONG *, ULONG, ULONG, ULONG, ULONG, ULONG *, ULONG * );
STDAPI_(void) X360C_SetActuator( UCHAR *, UCHAR, LONG, LONG, LONG );

//	Math.c
STDAPI_(LONG) Sin( LONG );
STDAPI_(LONG) Cos( LONG );
STDAPI_(LONG) ATan2( LONG, LONG );
STDAPI_(LONG) Sqrt( LONG );
