
//	Force Feedback Driver for Microsoft Xbox 360 Controller

#include	"X360CFF.h"

//----------------------------------------------------------------------------------------------
//	O[oϐ錾
//----------------------------------------------------------------------------------------------

LONG				ReferenceCount;
CRITICAL_SECTION	CriticalSection;

//----------------------------------------------------------------------------------------------
//	IncrementReference
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) IncrementReference()
{
	//	QƃJE^Z
	return( InterlockedIncrement( &ReferenceCount ) );
}

//----------------------------------------------------------------------------------------------
//	DecrementReference
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) DecrementReference()
{
	//	QƃJE^Z
	return( InterlockedDecrement( &ReferenceCount ) );
}

//----------------------------------------------------------------------------------------------
//	EnterCritical
//----------------------------------------------------------------------------------------------
STDAPI_(void) EnterCritical()
{
	//	NeBJ ZNVɓ
	EnterCriticalSection( &CriticalSection );
}

//----------------------------------------------------------------------------------------------
//	LeaveCritical
//----------------------------------------------------------------------------------------------
STDAPI_(void) LeaveCritical()
{
	//	NeBJ ZNVo
	LeaveCriticalSection( &CriticalSection );
}

//----------------------------------------------------------------------------------------------
//	AddLink
//----------------------------------------------------------------------------------------------
STDAPI_(void) AddLink(
	 PLINK_LIST *	LinkList
	,DWORD			Handle
	,PEFFECT		Effect )
{
	//	ϐ錾
	PLINK_LIST	WorkLink;

	//	N Xgɒǉ
	if( *LinkList == NULL )
	{
		//	ŏ̂Pǉ
		*LinkList	= (VOID *)LocalAlloc( LPTR, sizeof( LINK_LIST ) );
		(*LinkList)->Prev	= NULL;
		(*LinkList)->Handle	= Handle;
		(*LinkList)->Effect	= Effect;
		(*LinkList)->Next	= NULL;
	} else {
		//	N Xg̍ŌɈړ
		WorkLink	= (*LinkList);
		while( WorkLink->Next != NULL )
		{
			WorkLink	= WorkLink->Next;
		}
		//	Ō̂Pɒǉ
		WorkLink->Next	= (PLINK_LIST)LocalAlloc( LPTR, sizeof( LINK_LIST ) );
		((PLINK_LIST)WorkLink->Next)->Prev		= WorkLink;
		((PLINK_LIST)WorkLink->Next)->Handle	= Handle;
		((PLINK_LIST)WorkLink->Next)->Effect	= Effect;
		((PLINK_LIST)WorkLink->Next)->Next		= NULL;
	}
}

//----------------------------------------------------------------------------------------------
//	SearchLink
//----------------------------------------------------------------------------------------------
STDAPI_(PEFFECT) SearchLink(
	 PLINK_LIST *	LinkList
	,DWORD			Handle )
{
	//	ϐ錾
	PLINK_LIST	WorkLink;

	//	N Xg̍Ō܂Ō
	WorkLink	= (*LinkList);
	while( WorkLink != NULL )
	{
		if( WorkLink->Handle == Handle )
		{
			return( WorkLink->Effect );
		}
		WorkLink	= WorkLink->Next;
	}

	return( NULL );
}

//----------------------------------------------------------------------------------------------
//	DelLink
//----------------------------------------------------------------------------------------------
STDAPI_(void) DelLink(
	 PLINK_LIST *	LinkList
	,DWORD			Handle )
{
	//	ϐ錾
	PLINK_LIST	WorkLink;
	PLINK_LIST	NextLink;

	//	N XgȂ牽Ȃ
	if( *LinkList == NULL )
	{
		return;
	}

	//	N Xg폜
	WorkLink	= (*LinkList);
	do
	{
		//	̃NێĂ
		NextLink	= WorkLink->Next;
		//	Y郊N폜
		if( WorkLink->Handle == Handle )
		{
			//	ÕN𒲐
			if( WorkLink->Prev != NULL )
			{
				((PLINK_LIST)WorkLink->Prev)->Next	= WorkLink->Next;
			}
			//	̃N𒲐
			if( WorkLink->Next != NULL )
			{
				((PLINK_LIST)WorkLink->Next)->Prev	= WorkLink->Prev;
			}
			//	ŏ̂PȂ烊N XgύX
			if( WorkLink->Prev == NULL
			&&	WorkLink->Next != NULL )
			{
				*LinkList	= WorkLink->Next;
			}
			//	Ō̂PȂ烊N Xg폜
			if( WorkLink->Prev == NULL
			&&	WorkLink->Next == NULL )
			{
				*LinkList	= NULL;
			}
			//	N폜
			LocalFree( WorkLink );
		}
		WorkLink	= NextLink;
	}
	while( WorkLink != NULL );
}
