
//	Status Area for Microsoft Xbox 360 Controller

#include	"X360CSA.h"

//----------------------------------------------------------------------------------------------
//	GetSupportDeviceCount
//----------------------------------------------------------------------------------------------
STDAPI_(LONG) GetSupportDeviceCount()
{
	//	ϐ錾
	DWORD	DeviceCount	= 0;

	//	T|[gĂRg[̐擾
	GetRegistry( &DeviceCount, REG_DWORD, sizeof( DeviceCount ), SUPPORT_DEVICE_COUNT );

	return( DeviceCount );
}

//----------------------------------------------------------------------------------------------
//	GetSupportDeviceList
//----------------------------------------------------------------------------------------------
STDAPI_(void) GetSupportDeviceList(
	 ULONG * *	DeviceList
	,LONG		DeviceCount )
{
	//	ϐ錾
	LONG	DeviceIndex;
	_TCHAR	DeviceAttribute[MAX_PATH];

	//	T|[gĂRg[̃x_[hcAv_Nghc擾
	*DeviceList	= (ULONG *)LocalAlloc( LPTR, DeviceCount * sizeof( ULONG ) );
	for( DeviceIndex = 0; DeviceIndex < DeviceCount; DeviceIndex ++ )
	{
		_stprintf( DeviceAttribute, SUPPORT_DEVICE_ATTRIBUTE, DeviceIndex );
		GetRegistry(
			 &((*DeviceList)[DeviceIndex])
			,REG_DWORD
			,sizeof( ULONG )
			,DeviceAttribute );
	}
}

//----------------------------------------------------------------------------------------------
//	IoDevice
//----------------------------------------------------------------------------------------------
STDAPI_(BOOL) IoDevice( LONG Mode )
{
	//	ϐ錾
	GUID								GUID_HID;
	HDEVINFO							DevInfo;
	SP_INTERFACE_DEVICE_DATA			Interface;
	PSP_INTERFACE_DEVICE_DETAIL_DATA	Detail;
	BOOL								Result;
	HANDLE								hDevice;
	HIDD_ATTRIBUTES						HidAttribute;
	BYTE								Output[4];
	DWORD								Index;
	DWORD								ReqLen;
	BOOL								TargetDeviceFound;
	ULONG								DeviceIndex;
	BOOL								DeviceFound	= FALSE;

	//	foCX NX̃nh擾
	HidD_GetHidGuid(&GUID_HID);
	DevInfo	= SetupDiGetClassDevs(
				 &GUID_HID
				,NULL
				,NULL
				,DIGCF_PRESENT | DIGCF_INTERFACEDEVICE );
	if( DevInfo == INVALID_HANDLE_VALUE )
	{
		return( DeviceFound );
	}

	//	Ώۂ̃C^[tFCXT
	Index	= 0;
	while( TRUE )
	{
		//	C^[tFCX擾
		Interface.cbSize	= sizeof( Interface );
		if( !SetupDiEnumDeviceInterfaces( DevInfo, NULL, &GUID_HID, Index, &Interface ) )
		{
			SetupDiDestroyDeviceInfoList( DevInfo );
			return( DeviceFound );
		}

		//	C^[tFCX̏ڍ׏̃TCY擾
		SetupDiGetDeviceInterfaceDetail( DevInfo, &Interface, NULL, 0, &ReqLen, NULL );

		//	C^[tFCX̏ڍ׏擾
		Detail	= (PSP_INTERFACE_DEVICE_DETAIL_DATA)LocalAlloc( LPTR, ReqLen );
		if( Detail == NULL )
		{
			return( DeviceFound );
		}
		Detail->cbSize	= sizeof( SP_INTERFACE_DEVICE_DETAIL_DATA );
		Result	= SetupDiGetDeviceInterfaceDetail(
					 DevInfo
					,&Interface
					,Detail
					,ReqLen
					,NULL
					,NULL );
		if( !Result )
		{
			SetupDiDestroyDeviceInfoList( DevInfo );
			LocalFree( Detail );
			return( DeviceFound );
		}

		//	foCX C^[tFCXJ
		hDevice	= CreateFile(
					 Detail->DevicePath
					,GENERIC_READ | GENERIC_WRITE
					,FILE_SHARE_READ | FILE_SHARE_WRITE
					,NULL
					,OPEN_EXISTING
					,FILE_ATTRIBUTE_NORMAL
					,NULL );
		if( hDevice == INVALID_HANDLE_VALUE )
		{
			LocalFree( Detail );
			Index	++;
			continue;
		}

		//	C^[tFCX̏ڍׂɃx_R[hAv_NgR[h܂܂邩`FbN
		HidD_GetAttributes( hDevice, &HidAttribute );
		TargetDeviceFound	= FALSE;
		for( DeviceIndex = 0; DeviceIndex < SupportDeviceCount; DeviceIndex ++ )
		{
			if(	HidAttribute.VendorID  == HIWORD( SupportDeviceAttribute[DeviceIndex] )
			&&	HidAttribute.ProductID == LOWORD( SupportDeviceAttribute[DeviceIndex] ) )
			{
				TargetDeviceFound	= TRUE;
				break;
			}
		}
		if( TargetDeviceFound == TRUE )
		{
			if( Mode == APPLY_DEVICE )
			{
				//	foCXփWXgǂݒ悤Ɏw
				Output[0]	= 0;
				Output[1]	= 0;
				Output[2]	= 0;
				Output[3]	= 255;
				WriteFile( hDevice, Output, sizeof( Output ), &ReqLen, NULL );
			}
			DeviceFound	= TRUE;
		}

		//	foCX C^[tFCX
		CloseHandle( hDevice );

		//	̃C^[tFCX
		LocalFree( Detail );
		Index	++;
	}

	//	foCX NX̃nhJ
	SetupDiDestroyDeviceInfoList( DevInfo );

	return( DeviceFound );
}
