
//	Status Area for Microsoft Xbox 360 Controller

#include	"X360CSA.h"

//----------------------------------------------------------------------------------------------
//	O[oϐ
//----------------------------------------------------------------------------------------------

HINSTANCE				Instance;

ULONG					SupportDeviceCount;
ULONG *					SupportDeviceAttribute;

DWORD					EnableAutomaticChange;

//----------------------------------------------------------------------------------------------
//	WinMain
//----------------------------------------------------------------------------------------------
int WINAPI WinMain(
	 HINSTANCE	InstanceHandle
	,HINSTANCE	PrevInstanceHandle
	,LPSTR		CmdLine
	,int		CmdShow )
{
	//	ϐ錾
	HANDLE		Mutex;
	ATOM		Atom;
	HWND		Wnd;
	MSG			Msg;
	BOOL		Result;

	//	AvP[V̕Nh~
	Mutex	= CreateMutex( NULL, TRUE, X360CSA_MUTEX_NAME );
	if( GetLastError() == ERROR_ALREADY_EXISTS )
	{
		return( ERROR_ALREADY_EXISTS );
	}

	//	AvP[ṼCX^Xۑ
	Instance	= InstanceHandle;

	//	EBhE NXo^
	Atom	= RegisterMyClass();
	if( Atom == 0 )
	{
		return( 0 );
	}

	//	o^EBhE NXEBhE쐬
	Wnd	= CreateMyWindow();
	if( Wnd == NULL )
	{
		return( 0 );
	}

	//	bZ[W [v
	for(;;)
	{
		//	bZ[W L[烁bZ[W擾
		Result	= GetMessage( &Msg, NULL, 0, 0 );
		//	擾Ɏsꍇ͏I
		if( Result == -1 )
		{
			return( 0 );
		}
		//	WM_QUIT bZ[W擾ꍇ̓[vI
		if( Result == 0 )
		{
			break;
		}

		//	zL[ bZ[W𕶎bZ[W֕ϊ
		TranslateMessage( &Msg );
		//	bZ[WEBhE vV[W֑o
		DispatchMessage( &Msg );
	}

	//	~[ebNXJ
	CloseHandle( Mutex );

	//	WM_QUIT bZ[W̏IR[hԂ
	return( (int)Msg.wParam );
}

//----------------------------------------------------------------------------------------------
//	RegisterMyClass
//----------------------------------------------------------------------------------------------
ATOM RegisterMyClass()
{
	//	ϐ錾
	WNDCLASSEX	wcex;
	_TCHAR		ClassName[32];

	//	\[XEBhE NX[h
	LoadString( Instance, IDS_CLASS_NAME, ClassName, sizeof( ClassName ) );

	//	EBhE NX̑ݒ肷
	ZeroMemory( &wcex, sizeof( wcex ) );
	wcex.cbSize			= sizeof( wcex );
	wcex.style			= 0;
	wcex.lpfnWndProc	= WindowProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= Instance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= LoadCursor( NULL, IDC_ARROW );
	wcex.hbrBackground	= NULL;
	wcex.lpszMenuName	= NULL;
	wcex.lpszClassName	= ClassName;
	wcex.hIconSm		= NULL;

	//	EBhE NXo^
	return( RegisterClassEx( &wcex ) );
}

//----------------------------------------------------------------------------------------------
//	CreateMyWindow
//----------------------------------------------------------------------------------------------
HWND CreateMyWindow()
{
	//	ϐ錾
	HWND	Wnd;
	_TCHAR	ClassName[32];
	_TCHAR	WindowName[32];

	//	\[XEBhE NXƃEBhE[h
	LoadString( Instance, IDS_CLASS_NAME, ClassName, sizeof( ClassName ) );
	LoadString( Instance, IDS_WINDOW_NAME, WindowName, sizeof( WindowName ) );

	//	o^EBhE NXEBhE쐬
	Wnd	= CreateWindowEx(
			 0
			,ClassName
			,WindowName
			,WS_OVERLAPPEDWINDOW
			,CW_USEDEFAULT
			,CW_USEDEFAULT
			,CW_USEDEFAULT
			,CW_USEDEFAULT
			,NULL
			,NULL
			,Instance
			,NULL );

	//	쐬ʂԂ
	return( Wnd );
}

//----------------------------------------------------------------------------------------------
//	WindowProc
//----------------------------------------------------------------------------------------------
LRESULT CALLBACK WindowProc(
	 HWND	Wnd
	,UINT	Msg
	,WPARAM	wParam
	,LPARAM lParam )
{
	//	ϐ錾
	static	UINT	TaskbarRestart;
			DWORD	ProcessID;
	static	DWORD	PrevProcessID;
			LRESULT	Result	= 0;

	//	bZ[WɂďU蕪
	switch( Msg )
	{
		//	EBhE쐬
		case WM_CREATE:
			//	WXg茻݂̐ݒ擾
			SupportDeviceCount	= GetSupportDeviceCount();
			GetSupportDeviceList( &SupportDeviceAttribute, SupportDeviceCount );
			GetRegistry(
				 &EnableAutomaticChange
				,REG_DWORD
				,sizeof( EnableAutomaticChange )
				,AUTOMATIC_CHANGE );

			//	^XN o[̍č쐬ɔ
			TaskbarRestart	= RegisterWindowMessage( _T( "TaskbarCreated" ) );

			//	foCXL΃Xe[^X GAɃACRǉ
			if( IoDevice( SEARCH_DEVICE ) == TRUE )
			{
				ChangeStatusArea( Wnd, ADD_ICON );
			}

			//	ݒ̎؊p^C}[Jn
			if( EnableAutomaticChange == TRUE )
			{
				SetTimer( Wnd, CHECK_TIMER, 0, NULL );
			}
			break;

		//	Xe[^X GÃCxg
		case WM_STATUS_AREA_NOTIFY:
			if( wParam == STATUS_AREA_ID )
			{
				switch( lParam )
				{
					case WM_LBUTTONDOWN:
						//	^C}[Ńj[ij\
						SetTimer( Wnd, CLICK_TIMER, GetDoubleClickTime(), NULL );
						break;

					case WM_LBUTTONDBLCLK:
						//	NbNp^C}[~
						KillTimer( Wnd, CLICK_TIMER );
						//	Q[ Rg[J
						ShowGameController( Wnd );
						break;

					case WM_RBUTTONUP:
						//	j[iEj\
						ShowRightPopupMenu( Wnd );
						break;
				}
			}
			break;

		//	R}h
		case WM_COMMAND:
			switch( LOWORD(wParam) )
			{
				case IDM_OPEN_GAME_CONTROLLER:
					//	Q[ Rg[J(O)
					ShowGameController( Wnd );
					break;

				case IDM_AUTOMATIC_CHANGE:
					//	ݒ̎؊(A)
					if( EnableAutomaticChange == TRUE )
					{
						//	ݒ̎؊~
						EnableAutomaticChange	= FALSE;
						KillTimer( Wnd, CHECK_TIMER );
					} else {
						//	ݒ̎؊Jn
						EnableAutomaticChange	= TRUE;
						SetTimer( Wnd, CHECK_TIMER, 0, NULL );
					}
					break;

				case IDM_EXIT:
					//	I(X)
					PostMessage( Wnd, WM_CLOSE, 0, 0 );
					break;

				default:
					//	Rg[̐ݒύX
					if(	( CheckControlPanelState() == FALSE )
					&&	( IDM_SETTING <= LOWORD(wParam) )
					&&	( LOWORD(wParam) < IDM_SETTING + GetSettingCount() )
					&&	( LOWORD(wParam) != IDM_SETTING + GetCurrentSettingIndex() ) )
					{
						ChangeSetting( Wnd, LOWORD(wParam) - IDM_SETTING );
					}
					break;
			}
			break;

		//	tHA OEh̃AvP[VɂĎIɐݒ؊
		case WM_TIMER:
			switch( wParam )
			{
				case CLICK_TIMER:
					//	NbNp^C}[~
					KillTimer( Wnd, wParam );
					//	|bvAbv j[ij\
					ShowLeftPopupMenu( Wnd );
					break;

				case CHECK_TIMER:
					//	ݒ̎؊p^C}[~
					KillTimer( Wnd, wParam );

					//	tHA OEh̃AvP[ṼvZX ID 擾
					GetWindowThreadProcessId( GetForegroundWindow(), &ProcessID );
					if( PrevProcessID != ProcessID )
					{
						//	ݒ̎؊s
						if(	( CheckControlPanelState() == FALSE )
						&&	( GetModifiedFlag() == FALSE ) )
						{
							AutomaticChange( Wnd, ProcessID );
							//	vZX ID ޔ
							PrevProcessID	= ProcessID;
						}
					}

					//	ݒ̎؊p^C}[Jn
					SetTimer( Wnd, wParam, CHECK_INTERVAL, NULL );
					break;
			}
			break;

		//	foCX̕ύXmF
		case WM_DEVICECHANGE:
			//	foCX̗LɂăACR̕\A\؊
			if( IoDevice( SEARCH_DEVICE ) == TRUE )
			{
				//	Xe[^X GAɃACRǉ
				ChangeStatusArea( Wnd, ADD_ICON );
			} else {
				//	Xe[^X GAACR폜
				ChangeStatusArea( Wnd, DELETE_ICON );
			}
			Result	= TRUE;
			break;

		//	EBhEj
		case WM_DESTROY:
			//	Xe[^X GAACR폜
			ChangeStatusArea( Wnd, DELETE_ICON );

			//	ݒۑ
			SetRegistry(
				 &EnableAutomaticChange
				,REG_DWORD
				,sizeof( EnableAutomaticChange )
				,AUTOMATIC_CHANGE );

			//	AvP[VI
			PostQuitMessage( 0 );
			break;

		//	̃EBhE vV[WĂяo
		default:
			//	^XN o[č쐬ꂽH
			if( Msg == TaskbarRestart )
			{
				//	foCXL΃Xe[^X GAɃACRǉ
				if( IoDevice( SEARCH_DEVICE ) == TRUE )
				{
					ChangeStatusArea( Wnd, ADD_ICON );
				}
			}

			Result	= DefWindowProc( Wnd, Msg, wParam, lParam );
			break;
	}

	//	bZ[W̌ʂԂ
	return( Result );
}

//----------------------------------------------------------------------------------------------
//	ChangeStatusArea
//----------------------------------------------------------------------------------------------
STDAPI_(void) ChangeStatusArea(
	 HWND	Wnd
	,BOOL	AddOrDel )
{
	//	ϐ錾
	static	NOTIFYICONDATA	IconData;

	if( AddOrDel == ADD_ICON )
	{
		//	Xe[^X GAɃACRǉ
		ZeroMemory( &IconData, sizeof( IconData ) );
		IconData.cbSize				= sizeof( IconData );
		IconData.hWnd				= Wnd;
		IconData.uID				= STATUS_AREA_ID;
		IconData.uFlags				= NIF_MESSAGE | NIF_ICON | NIF_TIP;
		IconData.uCallbackMessage	= WM_STATUS_AREA_NOTIFY;
		IconData.hIcon				= (HICON)LoadImage(
										 Instance
										,MAKEINTRESOURCE( IDI_ICON )
										,IMAGE_ICON
										,0
										,0
										,LR_DEFAULTSIZE );
		LoadString( Instance, IDS_ICON_TIP, IconData.szTip, sizeof( IconData.szTip ) );
		Shell_NotifyIcon( NIM_ADD, &IconData );
		//	ACR폜
		if( IconData.hIcon != NULL )
		{
			DestroyIcon( IconData.hIcon );
		}
	} else {
		//	Xe[^X GAACR폜
		IconData.cbSize	= sizeof( IconData );
		IconData.hWnd	= Wnd;
		IconData.uID	= STATUS_AREA_ID;
		IconData.uFlags	= 0;
		Shell_NotifyIcon( NIM_DELETE, &IconData );
	}
}

//----------------------------------------------------------------------------------------------
//	ShowGameController
//----------------------------------------------------------------------------------------------
STDAPI_(void) ShowGameController( HWND Wnd )
{
	//	Q[ Rg[̃Rg[ plJ
	ShellExecute(
		 Wnd
		,_T( "open" )
		,_T( "RUNDLL32.EXE" )
		,_T( "SHELL32.DLL,Control_RunDLL joy.cpl" )
		,NULL
		,SW_SHOWNORMAL );
}

//----------------------------------------------------------------------------------------------
//	CheckControlPanelState
//----------------------------------------------------------------------------------------------
STDAPI_(BOOL) CheckControlPanelState()
{
	//	ϐ錾
	HANDLE	Mutex;

	//	Rg[ plƂ̔rs
	Mutex	= CreateMutex( NULL, FALSE, X360CCP_MUTEX_NAME );
	if( GetLastError() == ERROR_ALREADY_EXISTS )
	{
		//	~[ebNXJ
		CloseHandle( Mutex );
		//	Rg[ pl͊JĂ
		return( TRUE );
	} else {
		//	~[ebNXJ
		CloseHandle( Mutex );
		//	Rg[ pl͕Ă
		return( FALSE );
	}
}

//----------------------------------------------------------------------------------------------
//	ShowLeftPopupMenu
//----------------------------------------------------------------------------------------------
STDAPI_(void) ShowLeftPopupMenu( HWND Wnd )
{
	//	ϐ錾
	BOOL			ControlPanelOpened;
	HMENU			PopupMenu;
	MENUITEMINFO	ItemInfo;
	_TCHAR			MenuName[MAX_PATH];
	POINT			CursorPos;
	LONG			CurrentSettingIndex;
	BOOL			ModifiedFlag;
	_TCHAR			Modified[MAX_PATH];
	int				Index;

	//	Rg[ pl̏Ԃ擾
	ControlPanelOpened	= CheckControlPanelState();

	//	Rg[̐ݒ擾Ă
	CurrentSettingIndex	= GetCurrentSettingIndex();
	ModifiedFlag		= GetModifiedFlag();
	LoadString( Instance, IDS_MODIFIED, Modified, sizeof( Modified ) );

	//	|bvAbv j[쐬
	PopupMenu	= CreatePopupMenu();

	//	W̐ݒ
	ZeroMemory( &ItemInfo, sizeof( ItemInfo ) );
	ItemInfo.cbSize		= sizeof( ItemInfo );
	ItemInfo.fMask		= MIIM_TYPE | MIIM_STATE | MIIM_ID;
	ItemInfo.fType		= MFT_STRING;
	ItemInfo.fState		= MFS_ENABLED;
	if( ControlPanelOpened == TRUE )
	{
		ItemInfo.fState		|= MFS_DISABLED;
	}
	ItemInfo.wID		= IDM_SETTING;
	LoadString( Instance, IDS_DEFAULT_SETTING, MenuName, sizeof( MenuName ) );
	if( CurrentSettingIndex == 0 )
	{
		ItemInfo.fState		|= MFS_CHECKED;
		if( ModifiedFlag != FALSE  )
		{
			_tcscat( MenuName, Modified );
		}
	}
	ItemInfo.dwTypeData	= MenuName;
	InsertMenuItem( PopupMenu, 0, TRUE, &ItemInfo );

	//	Rg[̐ݒ
	for( Index = 1; Index < GetSettingCount(); Index ++ )
	{
		ZeroMemory( &ItemInfo, sizeof( ItemInfo ) );
		ItemInfo.cbSize		= sizeof( ItemInfo );
		ItemInfo.fMask		= MIIM_TYPE | MIIM_STATE | MIIM_ID;
		ItemInfo.fType		= MFT_STRING;
		ItemInfo.fState		= MFS_ENABLED;
		if( ControlPanelOpened == TRUE )
		{
			ItemInfo.fState		|= MFS_DISABLED;
		}
		ItemInfo.wID		= IDM_SETTING + Index;
		GetSettingName( MenuName, sizeof( MenuName ), Index );
		if( CurrentSettingIndex == Index )
		{
			ItemInfo.fState		|= MFS_CHECKED;
			if( ModifiedFlag != FALSE  )
			{
				_tcscat( MenuName, Modified );
			}
		}
		ItemInfo.dwTypeData	= MenuName;
		InsertMenuItem( PopupMenu, Index, TRUE, &ItemInfo );
	}

	//	|bvAbv j[\
	SetForegroundWindow( Wnd );
	GetCursorPos( &CursorPos );
	TrackPopupMenuEx(
		 PopupMenu
		,TPM_LEFTALIGN | TPM_RIGHTBUTTON
		,CursorPos.x
		,CursorPos.y
		,Wnd
		,NULL );
	DestroyMenu( PopupMenu );
	PostMessage( Wnd, WM_NULL, 0, 0 );
}

//----------------------------------------------------------------------------------------------
//	ShowRightPopupMenu
//----------------------------------------------------------------------------------------------
STDAPI_(void) ShowRightPopupMenu( HWND Wnd )
{
	//	ϐ錾
	HMENU			PopupMenu;
	MENUITEMINFO	ItemInfo;
	_TCHAR			MenuName[MAX_PATH];
	POINT			CursorPos;
	int				Index	= 0;

	//	|bvAbv j[쐬
	PopupMenu	= CreatePopupMenu();

	//	Q[ Rg[J(O)
	ZeroMemory( &ItemInfo, sizeof( ItemInfo ) );
	ItemInfo.cbSize		= sizeof( ItemInfo );
	ItemInfo.fMask		= MIIM_TYPE | MIIM_STATE | MIIM_ID;
	ItemInfo.fType		= MFT_STRING;
	ItemInfo.fState		= MFS_ENABLED | MFS_DEFAULT;
	ItemInfo.wID		= IDM_OPEN_GAME_CONTROLLER;
	LoadString( Instance, IDS_OPEN_GAME_CONTROLLER, MenuName, sizeof( MenuName ) );
	ItemInfo.dwTypeData	= MenuName;
	InsertMenuItem( PopupMenu, Index++, TRUE, &ItemInfo );

	//	ݒ̎؊(A)
	ZeroMemory( &ItemInfo, sizeof( ItemInfo ) );
	ItemInfo.cbSize		= sizeof( ItemInfo );
	ItemInfo.fMask		= MIIM_TYPE | MIIM_STATE | MIIM_ID;
	ItemInfo.fType		= MFT_STRING;
	ItemInfo.fState		= MFS_ENABLED;
	if( EnableAutomaticChange == TRUE )
	{
		ItemInfo.fState		|= MFS_CHECKED;
	}
	ItemInfo.wID		= IDM_AUTOMATIC_CHANGE;
	LoadString( Instance, IDS_AUTOMATIC_CHANGE, MenuName, sizeof( MenuName ) );
	ItemInfo.dwTypeData	= MenuName;
	InsertMenuItem( PopupMenu, Index++, TRUE, &ItemInfo );

	//	Zp[^
	ZeroMemory( &ItemInfo, sizeof( ItemInfo ) );
	ItemInfo.cbSize		= sizeof( ItemInfo );
	ItemInfo.fMask		= MIIM_TYPE;
	ItemInfo.fType		= MFT_SEPARATOR;
	InsertMenuItem( PopupMenu, Index++, TRUE, &ItemInfo );

	//	I(X)
	ZeroMemory( &ItemInfo, sizeof( ItemInfo ) );
	ItemInfo.cbSize		= sizeof( ItemInfo );
	ItemInfo.fMask		= MIIM_TYPE | MIIM_STATE | MIIM_ID;
	ItemInfo.fType		= MFT_STRING;
	ItemInfo.fState		= MFS_ENABLED;
	ItemInfo.wID		= IDM_EXIT;
	LoadString( Instance, IDS_EXIT, MenuName, sizeof( MenuName ) );
	ItemInfo.dwTypeData	= MenuName;
	InsertMenuItem( PopupMenu, Index++, TRUE, &ItemInfo );

	//	|bvAbv j[\
	SetForegroundWindow( Wnd );
	GetCursorPos( &CursorPos );
	TrackPopupMenuEx(
		 PopupMenu
		,TPM_LEFTALIGN | TPM_RIGHTBUTTON
		,CursorPos.x
		,CursorPos.y
		,Wnd
		,NULL );
	DestroyMenu( PopupMenu );
	PostMessage( Wnd, WM_NULL, 0, 0 );
}

//----------------------------------------------------------------------------------------------
//	AutomaticChange
//----------------------------------------------------------------------------------------------
STDAPI_(void) AutomaticChange(
	 HWND	Wnd
	,DWORD	ProcessID )
{
	//	ϐ錾
	HANDLE			ProcessSnapshot;

	_TCHAR			ModuleName[MAX_PATH];
	_TCHAR			SettingName[MAX_PATH];
	int				Index;
	SETTING			Setting;
	SETTING			PrevSetting;

	PROCESSENTRY32	ProcessEntry;

	//	vZX̃XibvVbg쐬
	ProcessSnapshot	= CreateToolhelp32Snapshot( TH32CS_SNAPPROCESS, 0 );

	//	vZX̃Gg擾
	ZeroMemory( &ProcessEntry, sizeof( PROCESSENTRY32 ) );
	ProcessEntry.dwSize = sizeof( PROCESSENTRY32 );
	Process32First( ProcessSnapshot, &ProcessEntry );
	//	SẴvZX
	do 
	{
		//	tHAOEh̃AvP[VT
		if( ProcessEntry.th32ProcessID == ProcessID )
		{
			//	W[؂o
			if( _tcschr( ProcessEntry.szExeFile, '\\' ) == NULL )
			{
				_tcscpy( ModuleName, ProcessEntry.szExeFile );
			} else {
				_tcscpy( ModuleName, &(_tcsrchr( ProcessEntry.szExeFile, '\\' )[1]) );
			}

			//	W[ƈvRg[̐ݒ
			for( Index = 1; Index < GetSettingCount(); Index ++ )
			{
				GetSettingName( SettingName, sizeof( SettingName ), Index );
				if(	( _tcsicmp( ModuleName, SettingName ) == 0 )
				&&	( GetCurrentSettingIndex() != Index ) )
				{
					//	Rg[̐ݒ؊
					GetSetting( &Setting, Index  );
					SetCurrentSetting( &Setting );
					SetCurrentSettingIndex( Index );
					SetModifiedFlag( FALSE );

					//	foCXɔf
					IoDevice( APPLY_DEVICE );
					break;
				}
			}
			break;
		}
	} while( Process32Next(ProcessSnapshot, &ProcessEntry ) ); 

	//	XibvVbg
	CloseHandle( ProcessSnapshot );
}

//----------------------------------------------------------------------------------------------
//	ChangeSetting
//----------------------------------------------------------------------------------------------
STDAPI_(void) ChangeSetting(
	 HWND	Wnd
	,LONG	Index )
{
	//	ϐ錾
	int		MsgResult;
	SETTING	Setting;
	SETTING	PrevSetting;

	//	ύXς݂ȂmF
	if( GetModifiedFlag() == TRUE )
	{
		MsgResult	= ShowMessageBox(
						 Wnd
						,IDS_WARNING_TITLE
						,IDS_WARNING_MESSAGE
						,MB_YESNO | MB_ICONQUESTION );
	} else {
		MsgResult	= IDYES;
	}

	//	Rg[̐ݒύX
	if( MsgResult == IDYES )
	{
		//	WXg茻݂̐ݒ擾
		GetDefaultSetting( &PrevSetting );
		GetCurrentSetting( &PrevSetting );

		//	WXgɌ݂̐ݒۑ
		GetSetting( &Setting, Index  );
		SetCurrentSetting( &Setting );
		SetCurrentSettingIndex( Index );
		SetModifiedFlag( FALSE );

		//	݊̐ݒ肪ςĂ΃_CAO\
		if( ( PrevSetting.DevicesArePolled	!= Setting.DevicesArePolled )
		||	( PrevSetting.LimitationMode	!= Setting.LimitationMode ) )
		{
			ShowMessageBox(
				 Wnd
				,IDS_RESTART_TITLE
				,IDS_RESTART_MESSAGE
				,MB_OK | MB_ICONINFORMATION );
		}

		//	foCXɔf
		IoDevice( APPLY_DEVICE );
	}
}
