
//	Status Area for Microsoft Xbox 360 Controller

#define	UNICODE
#define	_UNICODE

#include	<windows.h>
#include	<tchar.h>
#include	<stdio.h>
#include	<shellapi.h>
#include	<setupapi.h>
#include	<hidsdi.h>

#include	"Resource.h"

//----------------------------------------------------------------------------------------------
//	萔錾
//----------------------------------------------------------------------------------------------

#define	WM_STATUS_AREA_NOTIFY		WM_USER + 1
#define	STATUS_AREA_ID				0

#define	CLICK_TIMER					1
#define	CHECK_TIMER					2
#define CHECK_INTERVAL				1000

#define	SEARCH_DEVICE				0
#define	APPLY_DEVICE				1

#define	ADD_ICON					TRUE
#define	DELETE_ICON					FALSE

#define	X360CSA_MUTEX_NAME			_T( "X360CSA" )
#define	X360CCP_MUTEX_NAME			_T( "X360CCP" )

#define	REGISTRY_SUB_KEY			_T( "SYSTEM\\CurrentControlSet\\Services\\Xbox360Controller\\Parameters" )

#define	CURRENT_SETTING				_T( "Current Setting" )
#define	CURRENT_SETTING_INDEX		_T( "Current Setting Index" )
#define	SETTING_DATA				_T( "Setting %d" )
#define	SETTING_NAME				_T( "Setting Name %d" )
#define	SETTING_COUNT				_T( "Setting Count" )
#define	MODIFIED_FLAG				_T( "Modified Flag" )

#define	SUPPORT_DEVICE_COUNT		_T( "Support Device Count" )
#define	SUPPORT_DEVICE_ATTRIBUTE	_T( "Support Device Attribute %d" )

#define	AUTOMATIC_CHANGE			_T( "Automatic Change" )

#define	TH32CS_SNAPPROCESS			0x00000002

//----------------------------------------------------------------------------------------------
//	\̐錾
//----------------------------------------------------------------------------------------------

typedef struct _SETTING
{
	ULONG	StickUsage[2];
	ULONG	StickReverse[2];
	ULONG	StickMinThreshold;
	ULONG	StickMaxThreshold;
	ULONG	StickHatSwitchThreshold;
	ULONG	DirectionalPadUsage;
	ULONG	DirectionalPadReverse;
	ULONG	DirectionalPadWayUsage[4];
	ULONG	DirectionalPadWayRapidFire[4];
	ULONG	TriggerUsage[2];
	ULONG	TriggerRapidFire[2];
	ULONG	TriggerMinThreshold;
	ULONG	TriggerMaxThreshold;
	ULONG	TriggerButtonThreshold;
	ULONG	ButtonUsage[11];
	ULONG	ButtonRapidFire[11];
	ULONG	ButtonRapidFireSpeed[11];
	ULONG	RingLightPattern;
	ULONG	ForceFeedback;
	ULONG	ActuatorLevel[2];
	ULONG	ActuatorMinThreshold;
	ULONG	ActuatorMaxThreshold;
	ULONG	StickDeadZoneType;
	ULONG	SlideSliderValue[4];
	ULONG	SlideCenterValue[4];
	ULONG	ReverseSliderValue[4];
	ULONG	LimitationMode;
	ULONG	DevicesArePolled;
	ULONG	ReduceOutputReport;
} SETTING, *PSETTING;

typedef struct tagPROCESSENTRY32
{
	DWORD		dwSize;
	DWORD		cntUsage;
	DWORD		th32ProcessID;
	ULONG_PTR	th32DefaultHeapID;
	DWORD		th32ModuleID;
	DWORD		cntThreads;
	DWORD		th32ParentProcessID;
	LONG		pcPriClassBase;
	DWORD		dwFlags;
	_TCHAR		szExeFile[MAX_PATH];
} PROCESSENTRY32, *PPROCESSENTRY32;

//----------------------------------------------------------------------------------------------
//	O[oϐ
//----------------------------------------------------------------------------------------------

//	X360CSA.c
extern	HINSTANCE	Instance;
extern	ULONG		SupportDeviceCount;
extern	ULONG *		SupportDeviceAttribute;

//----------------------------------------------------------------------------------------------
//	֐錾
//----------------------------------------------------------------------------------------------

//	X360CSA.c
ATOM RegisterMyClass();
HWND CreateMyWindow();
LRESULT CALLBACK WindowProc( HWND, UINT, WPARAM, LPARAM );
STDAPI_(void) ChangeStatusArea( HWND, BOOL );
STDAPI_(BOOL) CheckControlPanelState();
STDAPI_(void) ShowGameController( HWND );
STDAPI_(void) ShowLeftPopupMenu( HWND );
STDAPI_(void) ShowRightPopupMenu( HWND );
STDAPI_(void) AutomaticChange( HWND, DWORD );
STDAPI_(void) ChangeSetting( HWND, LONG );

//	Setting.c
STDAPI_(void) GetDefaultSetting( SETTING * );
STDAPI_(void) SetCurrentSetting( SETTING * );
STDAPI_(void) GetCurrentSetting( SETTING * );
STDAPI_(void) SetCurrentSettingIndex( LONG );
STDAPI_(LONG) GetCurrentSettingIndex();
STDAPI_(void) SetSetting( SETTING *, LONG );
STDAPI_(void) GetSetting( SETTING *, LONG );
STDAPI_(void) GetSettingName( _TCHAR *, LONG, LONG );
STDAPI_(LONG) GetSettingCount();
STDAPI_(void) SetModifiedFlag( BOOL );
STDAPI_(BOOL) GetModifiedFlag();

//	Registry.c
STDAPI_(void) SetRegistry( VOID *, ULONG, ULONG, _TCHAR * );
STDAPI_(void) GetRegistry( VOID *, ULONG, ULONG, _TCHAR * );

//	Device.c
STDAPI_(LONG) GetSupportDeviceCount();
STDAPI_(void) GetSupportDeviceList( ULONG * *, LONG );
STDAPI_(BOOL) IoDevice( LONG );

//	ProcCommon.c
STDAPI_(LONG) ShowMessageBox( HWND, ULONG, ULONG, ULONG );

//	WIN32 tool help
HANDLE WINAPI CreateToolhelp32Snapshot( DWORD, DWORD );
#ifndef UNICODE
BOOL WINAPI Process32First( HANDLE, PPROCESSENTRY32 );
#else
BOOL WINAPI Process32FirstW( HANDLE, PPROCESSENTRY32 );
#define	Process32First	Process32FirstW
#endif
#ifndef UNICODE
BOOL WINAPI Process32Next( HANDLE, PPROCESSENTRY32 );
#else
BOOL WINAPI Process32NextW( HANDLE, PPROCESSENTRY32 );
#define	Process32Next	Process32NextW
#endif
